http://www.devshed.com/Server_Side/PHP/ErrorHandling/ErrorHandling1/

E_ERROR            1            Fatal runtime error 
E_WARNING          2            Non-fatal runtime error 
E_PARSE            4            Runtime parse error
E_NOTICE           8            Non-fatal runtime notice
E_CORE_ERROR       16           Fatal startup error
E_CORE_WARNING     32           Non-fatal startup error
E_COMPILE_ERROR    64           Fatal compile-time error
E_COMPILE_WARNING  128          Non-fatal compile-time error
E_USER_ERROR       256          User-triggered fatal error
E_USER_WARNING     512          User-triggered non-fatal error
E_USER_NOTICE      1024         User-triggered notice
E_ALL                           All of the above

trigger_error("", E_USER_WARNING);

function eh($type, $msg, $file, $line, $context)
{
<h1>Error!</h1>";
	echo "An error occurred while executing this script. Please
contact the <a href=mailto:webmaster@somedomain.com>webmaster</a> to
report this error.";
	echo "<p>";
	echo "Here is the information provided by the script:";
	echo "<hr><pre>";
	echo "Error code: $type<br>"; 
	echo "Error message: $message<br>"; 
	echo "Script name and line number of error: $file:$line<br>"; 
	echo "Variable state when error occurred: <br>";
	print_r($context); 
	echo "</pre><hr>";
}

// define a custom error handler
set_error_handler("eh");