<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = gestion des enregistrements pages et documents
* *************************************************************************************
* Creation mars 2002
* valid
**************************************************************************************/

Classe('classedb');

/**************************************************************************************
  page
**************************************************************************************/
class CClassPage extends CDBClasse
{
  var $id;
  var $doc;
  var $lang;

  function CClassPage($doc=0, $pos=0, $lang=0)
    {
    $this->CDBClasse('CClassPage');

    $req = NewQuery('SELECT pag_id FROM ratpages WHERE pag_position = '.$pos.' AND doc_id='.$doc);
    if($req->next_record()) $this->id = $req->f('pag_id'); else $this->id = 0;
    $this->lang = $lang;
    $this->doc = $doc;

    //from ratpages
    $this->champs[] = array('nom'=>'doc_id', 'type'=>typeEntier, 'table'=>'ratpages', 'valeur'=>$doc);
    $this->champs[] = array('nom'=>'pag_position', 'type'=>typeChaine, 'table'=>'ratpages', 'valeur'=>$pos);
    $this->champs[] = array('nom'=>'pag_ident', 'type'=>typeChaine, 'table'=>'ratpages', 'defaut'=>'');
    $this->champs[] = array('nom'=>'pag_creation', 'type'=>typeEntier, 'table'=>'ratpages', 'defaut'=>'NOW()');
    $this->champs[] = array('nom'=>'pag_modification', 'type'=>typeEntier, 'table'=>'ratpages', 'valeur'=>'NOW()', 'change'=>true);
    $this->champs[] = array('nom'=>'pag_visible', 'type'=>typeEntier, 'table'=>'ratpages', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'pag_texte', 'type'=>typeChaine, 'table'=>'ratpages', 'defaut'=>'');
    $this->champs[] = array('nom'=>'pag_commun', 'type'=>typeEntier, 'table'=>'ratpages', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'pag_refresh', 'type'=>typeEntier, 'table'=>'ratpages', 'valeur'=>'1', 'change'=>true);

    //from ratlnk_paglang
    $this->champs[] = array('nom'=>'pag_id', 'type'=>typeEntier, 'table'=>'ratlnk_paglang', 'valeur'=>0);
    $this->champs[] = array('nom'=>'lang_id', 'type'=>typeEntier, 'table'=>'ratlnk_paglang', 'valeur'=>$lang);
    $this->champs[] = array('nom'=>'pal_titre', 'type'=>typeChaine, 'table'=>'ratlnk_paglang', 'defaut'=>'');
    $this->champs[] = array('nom'=>'pal_visible', 'type'=>typeEntier, 'table'=>'ratlnk_paglang', 'defaut'=>false);
    $this->champs[] = array('nom'=>'pal_description', 'type'=>typeChaine, 'table'=>'ratlnk_paglang', 'defaut'=>'');
    $this->champs[] = array('nom'=>'pal_texte', 'type'=>typeChaine, 'table'=>'ratlnk_paglang', 'defaut'=>'');
    }

  function Sauver()
  //sauve les donnes dans la base
    {
    if($this->id==0) $sql = $this->SqlInsert('ratpages');
    else $sql = $this->SqlUpdate('ratpages', 'WHERE pag_id='.$this->id);

    if($sql!='')
      {
      NewQuery($sql);
      if($this->id==0)
        {
        $this->id = mysql_insert_id();
        $insert = 1;
        }
      }

    $req = NewQuery('SELECT * FROM ratlnk_paglang WHERE pag_id='.$this->id.' AND lang_id='.$this->lang);
    if(!$req->next_record()) $insert = 1;

    $this->Ecrire('pag_id', $this->id);
    if(isset($insert)) $sql = $this->SqlInsert('ratlnk_paglang');
    else $sql = $this->SqlUpdate('ratlnk_paglang', 'WHERE pag_id='.$this->id.' AND lang_id='.$this->lang);

    if($sql!='') NewQuery($sql);
    }

  function Charger()
  //charge les donnes de la base
    {
    $result1 = $this->ChargerDB('ratpages', 'WHERE pag_id='.$this->id);
    $result2 = $this->ChargerDB('ratlnk_paglang', 'WHERE pag_id='.$this->id.' AND lang_id='.$this->lang);
    if($result1==-1 or $result2==-1) return -1; else return 1;
    }

  function Position($valeur='')     { return $this->Acces('pag_position', $valeur); }
  function Ident($valeur='')         { return $this->Acces('pag_ident', $valeur); }
  function Visible($valeur='')       { return $this->Acces('pag_visible', $valeur); }
  function Texte($valeur='')         { return $this->Acces('pag_texte', $valeur); }
  function TexteCommun($valeur='')   { return $this->Acces('pag_commun', $valeur); }

  function Titre($valeur='')         { return $this->Acces('pal_titre', $valeur); }
  function VisLang($valeur='')       { return $this->Acces('pal_visible', $valeur); }
  function Description($valeur='')   { return $this->Acces('pal_description', $valeur); }
  function Texte($valeur='')         { return $this->Acces('pal_texte', $valeur); }
}

/**************************************************************************************
  document
**************************************************************************************/

class CClassDoc extends CDBClasse
  {
  var $id;
  var $lang;

  function CClassDoc($id=0, $lang=0)
    {
    $this->CDBClasse('CClassDoc');
    $this->id = $id;
    $this->lang = $lang;

    //from ratdocuments
    $this->champs[] = array('nom'=>'doc_designation', 'type'=>typeChaine, 'table'=>'ratdocuments', 'defaut'=>'');
    $this->champs[] = array('nom'=>'dos_id',           'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'doc_refresh',     'type'=>typeEntier, 'table'=>'ratdocuments', 'valeur'=>'1', 'change'=>true);
    $this->champs[] = array('nom'=>'doc_modification','type'=>typeEntier, 'table'=>'ratdocuments', 'valeur'=>'NOW()', 'change'=>true);
    $this->champs[] = array('nom'=>'doc_creation',     'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'NOW()');
    $this->champs[] = array('nom'=>'pers_id',         'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'doc_taille',       'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'mod_id',           'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'doc_visible',     'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'doc_entete',       'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'doc_navigation',   'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');
    $this->champs[] = array('nom'=>'doc_sommaire',     'type'=>typeEntier, 'table'=>'ratdocuments', 'defaut'=>'0');

    //from ratlnk_doclang
    $this->champs[] = array('nom'=>'doc_id',           'type'=>typeEntier, 'table'=>'ratlnk_doclang');
    $this->champs[] = array('nom'=>'lang_id',         'type'=>typeEntier, 'table'=>'ratlnk_doclang', 'valeur'=>$lang);
    $this->champs[] = array('nom'=>'dol_titre',       'type'=>typeChaine, 'table'=>'ratlnk_doclang', 'defaut'=>'');
    $this->champs[] = array('nom'=>'dol_motsclefs',   'type'=>typeChaine, 'table'=>'ratlnk_doclang', 'defaut'=>'');
    $this->champs[] = array('nom'=>'dol_description', 'type'=>typeChaine, 'table'=>'ratlnk_doclang', 'defaut'=>'');
    $this->champs[] = array('nom'=>'dol_visible',     'type'=>typeEntier, 'table'=>'ratlnk_doclang', 'defaut'=>false);
    }

  function Sauver()
    {
    if($this->id==0) $sql = $this->SqlInsert('ratdocuments');
    else $sql = $this->SqlUpdate('ratdocuments', 'WHERE doc_id='.$this->id);
    if($sql!='')
      {
      NewQuery($sql);
      if($this->id==0)
        {
        $this->id = mysql_insert_id();
        $insert = 1;
        }
      }
    $req = NewQuery('SELECT * FROM ratlnk_doclang WHERE doc_id='.$this->id.' AND lang_id='.$this->lang);
    if($req->next_record()) ; else $insert = 1;

    if(isset($insert))
      {
      $this->Ecrire('doc_id', $this->id);
      $sql = $this->SqlInsert('ratlnk_doclang');
      }
    else $sql = $this->SqlUpdate('ratlnk_doclang', 'WHERE doc_id='.$this->id.' AND lang_id='.$this->lang);

    if($sql!='') NewQuery($sql);
    }

  function Charger()
    {
    $result1 = $this->ChargerDB('ratdocuments', 'WHERE doc_id='.$this->id);
    $result2 = $this->ChargerDB('ratlnk_doclang', 'WHERE doc_id='.$this->id.' AND lang_id='.$this->lang);
    if($result1==-1 or $result2==-1) return -1; else return 1;
    }

  function Page($numero)
    {
    return (new CClassPage($this->id, $numero, $this->lang));
    }

  function Designation($valeur='')   { return $this->Acces('doc_designation', $valeur); }
  function Dossier($valeur='')       { return $this->Acces('dos_id', $valeur); }
  function Personne($valeur='')     { return $this->Acces('pers_id', $valeur); }
  function Taille($valeur='')       { return $this->Acces('doc_taille', $valeur); }
  function Module($valeur='')       { return $this->Acces('mod_id', $valeur); }
  function Visible($valeur='')       { return $this->Acces('doc_visible', $valeur); }
  function EnTete($valeur='')       { return $this->Acces('doc_entete', $valeur); }
  function Navigation($valeur='')   { return $this->Acces('doc_navigation', $valeur); }
  function Sommaire($valeur='')     { return $this->Acces('doc_sommaire', $valeur); }

  function Langue($valeur='')       { return $this->Acces('lang_id', $valeur); }
  function Titre($valeur='')         { return $this->Acces('dol_titre', $valeur); }
  function MotsClefs($valeur='')     { return $this->Acces('dol_motsclefs', $valeur); }
  function Description($valeur='')   { return $this->Acces('dol_description', $valeur); }
  function VisLang($valeur='')       { return $this->Acces('dol_visible', $valeur); }
  }

?>