<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric  
* Objet = gestion des rubriques de menu
* *************************************************************************************
* Creation 
* valid
**************************************************************************************/

Librairie('rawdata');
Librairie('documents');

function menu_refresh()
//flag de refresh du menu
	{
	setData('menu', 'menu.refresh', 1);
	}
	
function rubdoc_supprimer($doc_id, $rub_id)
//supprimer une rubrique
  {
  NewQuery('DELETE FROM ratlnk_rubdoc WHERE doc_id='.$doc_id.' AND rub_id='.$rub_id);
	menu_refresh();
  }
	
function rub_refresh($rub_id)
//supprimer une rubrique
  {
  NewQuery('UPDATE ratrubriques SET rub_doc_refresh=1 WHERE rub_id='.$rub_id);
  }
	
function rubdoc_refresh($doc_id)
	{
	$req = NewQuery('
		SELECT rub.rub_id 
		FROM ratlnk_rubdoc AS rud
			INNER JOIN ratrubriques AS rub ON (rub.maindoc_id is null or rub.maindoc_id=0) and rub.rub_id=rud.rub_id
			WHERE doc_id='.$doc_id);
	while($req->next_record()) rub_refresh($req->f('rub_id'));
	}

function rubdoc_titre($doc_id, $rub_id)
//rcupration du titre d'une rubrique
//todo : je me demande si cette fonction sert  quelque chose
  {
  $req = NewQuery('
    SELECT doc.doc_designation
    FROM ratdocuments AS doc
      INNER JOIN ratlnk_rubdoc AS rud ON rud.doc_id=doc.doc_id AND rud.rub_id='.$rub_id.'
    WHERE doc.doc_id='.$doc_id);
  if($req->next_record()) $result = $req->f('doc_designation');
  else trigger_error("document non trouve (doc $doc_id rub $rub_id)", E_USER_WARNING);
  return $result;
  }

function rub_changepere($fils, $newpere)
//changer le pere d'une rubrique
  {
  $req = NewQuery('
    SELECT rubpere_id, sit_id
    FROM ratrubriques
    WHERE rub_id='.$fils);
  if($req->next_record())
    {
    $ancienpere = $req->f('rubpere_id');
    $site = $req->f('sit_id');
    }
  else trigger_error("rubrique non trouvee (rub $fils)", E_USER_WARNING);

  if(empty($ancienpere)) $ancienpere = 0;

  NewQuery('
    UPDATE ratrubriques SET
      rubpere_id='.$newpere.',
      rub_place='.rub_GetNewPlace($newpere).'
    WHERE rub_id='.$fils);
  rub_defragplaces($ancienpere, $site);
	menu_refresh();
  }

function ComboListRubriques($selected, $idpere=0, $niveau='')
//retourne le remplissage d'une combobox avec la liste des rubriques
  {
  global $Session;
  $result = '';

  $req = NewQuery('
    SELECT r.rub_id, rul.rul_titre
    FROM ratrubriques AS r
      INNER JOIN ratlangues AS l ON l.lang_abrege="'.$Session['langue_edition'].'"
      INNER JOIN ratlnk_rublang AS rul ON rul.rub_id=r.rub_id AND rul.lang_id=l.lang_id
    WHERE r.sit_id='.$Session['site'].' AND r.rubpere_id='.$idpere.'
    ORDER BY r.rub_place');

  while($req->next_record())
    {
    $state = ($selected!='' && $selected==$req->f('rub_id'))?' selected':'';
    if($state!='') $autour = '-'; else $autour = '';
    $result .=
      '<option value="'.$req->f('rub_id').'"'.$state.'>'.$niveau.$autour.$req->f('rul_titre').$autour.'</option>'.
      ComboListRubriques($selected, $req->f('rub_id'), $niveau."&nbsp;&nbsp;&nbsp;&nbsp;");
    }
  return $result;
  }

function EstAncetre($rubancetre, $rubfils)
//vrifie si rubfils est dans la descendance de rubancetre
  {
  $result = $rubancetre==$rubfils;

  $req = NewQuery('SELECT rub_id FROM ratrubriques WHERE rubpere_id='.$rubancetre);
  while($req->next_record() && !$result)
    $result = $req->f('rub_id')==$rubfils || EstAncetre($req->f('rub_id'), $rubfils);
  return $result;
  }

function rub_titre($id)
//recupere le titre d'une rubrique en fonction de la langue courante
//todo : id_langue ne doit plus etre le bon truc, donc la fonction doit pas servir
  {
  global $Session;

  $req = NewQuery("
    SELECT rul.rul_titre
    FROM ratlnk_rublang AS rul
      INNER JOIN ratlangues AS l
      ON (l.lang_abrege='".$Session['id_langue']."' AND rul.lang_id=l.lang_id)
    WHERE rul.rub_id=".$id);
  if($req->next_record()) return $req->f('rul_titre');
  else trigger_error("rublang non trouvee (rub $id)", E_USER_WARNING);
  }

function rub_getpere($id)
//recupere l'id du pere de la rubrique
  {
  $req = NewQuery('SELECT rubpere_id FROM ratrubriques WHERE rub_id='.$id);
  if($req->next_record()) 
		if($req->f(('rubpere_id')!=0)) return $req->f('rubpere_id');
		else return 0;
  else trigger_error("rubrique non trouvee (rub $id)", E_USER_WARNING);
  }

function rub_defragplaces($pere, $site)
//rordonne les places des rubriques afin qu'elles soient 
//conscutives parmis les enfants de $pere
  {
  $req = NewQuery('
    SELECT rub_id, rub_place
    FROM ratrubriques
    WHERE sit_id='.$site.' AND rubpere_id='.$pere.'
    ORDER BY rub_place');
  $ct = 1;
  while($req->next_record())
    {
    NewQuery('UPDATE ratrubriques SET rub_place='.$ct.' WHERE rub_id='.$req->f('rub_id'));
    $ct++;
    }
	menu_refresh();
  }

function rub_GetNewPlace($pere)
//obtient la nouvelle place pour une rubrique (c'est  dire max+1)
  {
	global $Session;
  $req = NewQuery('
    SELECT MAX(rub_place) AS Nb FROM ratrubriques
    WHERE sit_id='.$Session['site'].' AND rubpere_id='.$pere);
  if(!$req->next_record()) return 1; else return $req->f('Nb')+1; 
  }

function rub_getinfos($id)
//rcupere le pere et le site pour une rubrique
  {
  $req = NewQuery("SELECT rubpere_id, sit_id, rub_doc_id FROM ratrubriques WHERE rub_id=".$id);
  if($req->next_record())
		{
		$pere = $req->f('rubpere_id')=='' ? 0 : $req->f('rubpere_id');
    return array($pere, $req->f('sit_id'), $req->f('rub_doc_id'));
		}
  else trigger_error("rubrique inconnue (rub $id)", E_USER_WARNING);
  }

function rub_supprimer($id, $defrag = 0)
//suppression d'une rubrique
  {
  list($pere, $site, $rubdoc) = rub_getinfos($id);
	
  NewQuery("DELETE FROM ratrubriques WHERE rub_id=".$id);
  NewQuery("DELETE FROM ratlnk_rubdoc WHERE rub_id=".$id);
  NewQuery("DELETE FROM ratlnk_rublang WHERE rub_id=".$id);
	if(!empty($rubdoc) and $rubdoc!=0) doc_supprimer($rubdoc);
  $req = NewQuery("SELECT rub_id FROM ratrubriques WHERE rubpere_id=".$id);
  while($req->next_record()) rub_supprimer($req->f('rub_id'), 1);
  if($defrag==1) rub_defragplaces($pere, $site);
	menu_refresh();
  }

function rub_visible_one($data, $valeur)
//change l'tat de visibilit d'une rubrique
  {
  NewQuery('UPDATE ratrubriques SET rub_visible='.$valeur.' WHERE rub_id='.$data);
  }

function rub_visible($data, $valeur)
//change l'tat de visibilit d'une rubrique ou d'un tableau de rubrique
  {
  if(is_array($data))
    {
    reset($data);
    while(list($key,) = each($data)) rub_visible_one($key, $valeur);
    }
  else rub_visible_one($data, $valeur);
	menu_refresh();
  }

function rub_bouger_one($data, $deplacement)
//dplace une rubrique
  {
  global $Session;

  $req = NewQuery('SELECT rub_place, rubpere_id FROM ratrubriques WHERE rub_id='.$data);
  if($req->next_record())
    {
    $rub_place = $req->f('rub_place');
    $rub_pere = $req->f('rubpere_id');
    if($rub_pere=='') $rub_pere = 0;

    if($deplacement==-1) //on monte
      {
      if($rub_place!=1)
        {
        NewQuery('
          UPDATE ratrubriques SET rub_place='.$rub_place.'
          WHERE rub_place='.($rub_place-1).' AND rubpere_id='.$rub_pere.' AND sit_id='.$Session['site']);
        NewQuery('
          UPDATE ratrubriques SET rub_place='.($rub_place-1).'
          WHERE rub_id='.$data);
        }
      }
    elseif($deplacement==+1) //on descend
      {
      $req = NewQuery('SELECT MAX(rub_place) as maxplace FROM ratrubriques WHERE rubpere_id='.$rub_pere);
      if($req->next_record())
        {
        if($rub_place != $req->f('maxplace'))
          {
          NewQuery('
            UPDATE ratrubriques SET rub_place='.$rub_place.'
            WHERE rub_place='.($rub_place+1).' AND rubpere_id='.$rub_pere.' AND sit_id='.$Session['site']);
          NewQuery('
            UPDATE ratrubriques SET rub_place='.($rub_place+1).'
            WHERE rub_id='.$data);
          }
        }
      else trigger_error("rubrique non trouvee (rub $rub_pere)", E_USER_WARNING);
      }
    }
  else trigger_error("rubrique non trouvee (rub $data)", E_USER_WARNING);
  }

function rub_bouger($data, $deplacement)
//dplace une rubrique ou un tableau de rubriques
  {
  if(is_array($data))
    {
    reset($data);
    while(list($key,) = each($data)) rub_bouger_one($key, $deplacement);
    }
  else rub_bouger_one($data, $deplacement);
	menu_refresh();
  }


?>