<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = quelques fonctions utilitaires
* *************************************************************************************
* Creation en dcembre 2001
* valid
**************************************************************************************/

function TxtSql($chaine)
  {
  //if(get_magic_quotes_gpc()==0)
    return str_replace('"', '\"', str_replace('\\', '\\\\', $chaine));
  //else return $chaine;
  }

function TxtHTML($chaine)
  {
  if(get_magic_quotes_gpc()==1) return htmlentities(stripslashes($chaine));
  else return htmlentities($chaine);
  }

function Txt($chaine)
  {
  if(get_magic_quotes_gpc()==1) return stripslashes($chaine);
  else return $chaine;
  }

function TxtXml($chaine)
  {
  return htmlspecialchars(utf8_encode($chaine));
  }

$liste_mois = array('erreur',
  'Janvier', 'Fvrier', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet',
  'Aot', 'Septembre', 'Octobre', 'Novembre', 'Dcembre');

function Vor0($var)
//retourne var si celle ci n'est pas vide, et 0 sinon
  {
  if(!empty($var)) return $var; else return '0';
  }

function VorN($var)
//retourne var si celle ci n'est pas vide, et null sinon
  {
  if(isset($var)) return $var; else return '';
  }

function ChaineFrm($ch)
//formate une chaine pour affichage en html
  {
  return str_replace(' ', '&nbsp;', $ch);
  }

function txtformat($s)
//formate un texte pour affichage (fin de ligne et slashes)
  {
  return nl2br(stripslashes($s));
  }

function Sql2options($sql, $selected = '')
//rempli une liste avec les rsultats d'une requete
//le champ clef doit s'appeler chp1, le champ affich chp2
  {
  $result = '';
  if(!isset($selected)) $selected=''; //pour eviter un message sous PHP3
  $db = NewQuery($sql);
  while($db->next_record())
    {
    if(($selected!='') && ($selected==$db->f('chp1')))
      $state = ' selected'; else $state='';
    $state = ($selected!='' && $selected==$db->f('chp1'))?' selected':'';
    $texte = TxtHTML($db->f('chp2'));
    if($db->f('chp3')!='') $texte .= '&nbsp;'.TxtHTML($db->f('chp3'));
    $result .= '<option value="'.$db->f('chp1').'"'.$state.'>'.$texte.'</option>';
    }
  return $result;
  }

function Tab2Options($tab, $selected = '')
//rempli une liste avec le contenu d'un tableau
  {
  $result = '';
  reset($tab);
  while(list($key, $val)=each($tab))
    {
    $state = ($selected!='' && $selected==$key)?' selected':'';
    $result .= '<option value="'.$key.'"'.$state.'>'.TxtHTML($val).'</option>';
    }
  return $result;
  }

function TabSimple2options($tab, $selected = '')
//rempli une liste avec le contenu d'un tableau sans prendre en compte la clef
  {
  $result = '';
  for($i=1, $max=count($tab); $i<$max; $i++)
    {
    $state = ($selected!='' && $selected==$i)?' selected':'';
    $result .= '<option value="'.$i.'"'.$state.'>'.$tab[$i].'</option>';
    }
  return $result;
  }

function Date_m2p($date)
//conversion de date entre mysql et php
  {
  return substr($date, 8, 2).'/'.substr($date, 5, 2).'/'.substr($date, 0, 4);
  }

function Date_m2pl($date)
  {
  return substr($date, 8, 2).'/'.substr($date, 5, 2).'/'.substr($date, 2, 2);
  }

function Date_p2m($date)
//conversion de date entre php et mysql
  {
  return substr($date, 6, 4).'-'.substr($date, 3, 2).'-'.substr($date, 0, 2);
  }

function DatesDeux($date1, $date2)
//retourne un intervale
  {
  if($date2=='' || $date1==$date2 || $date2==0)
    return Date_m2pl($date1);
  else return Date_m2pl($date1).'&nbsp;'.Date_m2pl($date2);
  }

function Date_valide($date)
//vrifie qu'une date est valide
  {
  return ereg('^[0-9]{2}/[0-9]{2}/[0-9]{4}$', $date);
  }

function numformat($num, $qte)
//formate un nombre en $num caractres
  {
  while(strlen($num)<$qte) $num = '0'.$num;
  return $num;
  }

function afftaille($taille)
//affiche une taille en octets
  {
  $mesures = array('o', 'ko', 'Mo', 'Go');
  $i=0;
  while($taille>1024)
    {
    $taille=$taille/1024;
    $i++;
    }
  return round($taille, 2).$mesures[$i];
  }

function slashes_quote($s)
//slash les '
  {
  return str_replace("'", "\'", $s);
  }

function slashes_guill($s)
//slash les "
  {
  return str_replace('"', '\"', $s);
  }

function aff_guill($s)
//remplace les guillements par le code html
  {
  return str_replace('"', '&quot;', $s);
  }

function SauveUpload($variable, &$data)
//sauve un fichier upload
  {
  global $HTTP_POST_FILES, $HTTP_POST_VARS;

  $result = 1;
  if(!empty($HTTP_POST_FILES[$variable])) $data = $HTTP_POST_FILES[$variable];
  elseif(!empty($HTTP_POST_VARS[$variable]))
    {
    $data['type']='unknown';
    $data['name']=$HTTP_POST_VARS[$variable."_name"];
    $data['size']=$HTTP_POST_VARS[$variable."_size"];
    $data['tmp_name']=$HTTP_POST_VARS[$variable];
    }
  else return false;

  $result=isset($data);
  return rat_chown($data['tmp_name']) && $result;
  return $result;
  }

function loadfile($file)
//retourne le contenu d'un fichier
  {
  $f = fopen($file, 'r');
  $result = fread($f, filesize($file));
  fclose($f);
  return $result;
  }

?>