<?

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
  'cmd_listdocs',
  'cmd_listfics',
  'cmd_ajouter',
  'cmd_supprconf',
  'cmd_supprimer',
  'cmd_annuler',
  'cmd_liensout',
  'cmd_pages');

/**************************************************************************************
  commandes
**************************************************************************************/
global $Session, $datamodule, $HTTP_POST_VARS;
Librairie('documents');
Librairie('dossiers');

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, 'doc', 'docs');
if(isset($datamodule['docs'])) unset($datamodule['docs']);

/**************************************************************************************
  gestion de la sauvegarde des infos
**************************************************************************************/
if(isset($HTTP_POST_VARS[IDENT_EDIT_DOC]))
  {
  $visible = isset($HTTP_POST_VARS['doc_visible']) ? 1 : 0;
  $visiblelang = isset($HTTP_POST_VARS['doc_visiblelang']) ? 1 : 0;
  $entete = isset($HTTP_POST_VARS['doc_entete']) ? 1 : 0;
  $navig = isset($HTTP_POST_VARS['doc_navig']) ? 1 : 0;
  $sommaire = isset($HTTP_POST_VARS['doc_sommaire']) ? 1 : 0;

  if(empty($datamodule['doc']))
    {
    trigger_error("datamodule['doc'] est vide", E_USER_WARNING);
    }
  else
    {
    $sql = 'UPDATE ratdocuments SET
      doc_designation = "'.TxtSql($HTTP_POST_VARS['doc_identifiant']).'",
      dos_id = '.$HTTP_POST_VARS['doc_dossier'].',
			';
		if($HTTP_POST_VARS['doc_auteur']!=0) $sql .= 'pers_id = '.$HTTP_POST_VARS['doc_auteur'].',';
		$sql .= '
        doc_entete = '.$entete.',
        doc_navigation = '.$navig.',
        doc_sommaire = '.$sommaire.',
        doc_modification = NOW(),
				doc_refresh = 1,
				doc_visible = '.$visible.'
      WHERE doc_id='.$datamodule['doc'];
		NewQuery($sql);
    NewQuery('UPDATE ratlnk_doclang SET
        dol_titre = "'.TxtSql($HTTP_POST_VARS['doc_titre']).'",
        dol_motsclefs = "'.TxtSql($HTTP_POST_VARS['doc_motsclefs']).'",
        dol_description = "'.TxtSql($HTTP_POST_VARS['doc_description']).'",
        dol_visible = '.$visiblelang.'
      WHERE doc_id='.$datamodule['doc'].' AND lang_id='.Langue_id($Session['langue_edition']));
    }

  GetParam('edititem', $edititem);
  if(!empty($edititem)) $datamodule['doc'] = $edititem;
  }

/**************************************************************************************
  gestion des commandes passes
**************************************************************************************/
switch($cmd)
  {
  case 'cmd_rien' : break;

  case 'cmd_listdocs' :
    $Session['mode'] = 'principal';
    break;

  case 'cmd_ajouter' :
    $datamodule['doc'] = doc_ajout(module_id($Session['module']), $Session['id_personne'],
      dossier_premier($Session['site']));
    break;

  case 'cmd_listfics' :
    $Session['mode'] = 'fichiers';
    break;

  case 'cmd_liensout' :
    $Session['mode'] = 'liensout';
    break;

  case 'cmd_pages' :
    $Session['mode'] = 'pages';
    break;

  case 'cmd_supprconf' :
    unset($HTTP_POST_VARS[IDENT_EDIT_DOC]);
    if(empty($datamodule['doc'])) $Session['mode'] = 'principal';
    elseif(!empty($datamodule['doc']))
      $datamodule['confirmation'] = 1;
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['doc']))
      {
      msg_ajout('suppression de "'.doc_designation($datamodule['doc']).'"'); //TODO TRADUCTION
      doc_supprimer($datamodule['doc']);
      unset($datamodule['doc']);
      $Session['mode'] = 'principal';
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

?>