<?

Librairie('fichiers');

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
  'cmd_listdocs',
  'cmd_editdoc',
  'cmd_supprconf',
  'cmd_supprimer',
  'cmd_annuler',
  'cmd_upload',
  'cmd_liensout',
  'cmd_pages');

/**************************************************************************************
  commandes
**************************************************************************************/
global $Session, $datamodule, $HTTP_POST_VARS;
Librairie('documents');

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, '', 'fics');
if(!empty($data)) $datamodule['fics'] = $data;

switch($cmd)
  {
  case 'cmd_rien' : break;

  case 'cmd_listdocs' :
    $Session['mode'] = 'principal';
    break;

   case 'cmd_editdoc' :
    $Session['mode'] = 'edit_main';
    break;

  case 'cmd_liensout' :
    $Session['mode'] = 'liensout';
    break;

  case 'cmd_pages' :
    $Session['mode'] = 'pages';
    break;

  case 'cmd_upload' :
    if(SauveUpload('fic_upload', $data))
      {
      $id_fic = Fichier_Ajout($datamodule['doc'], $data['name'], $data['type'], $data['size']);
      rename($data['tmp_name'], Fichier_Nom($datamodule['doc'], $id_fic, strrchr($data['name'], '.')));
      msg_ajout('upload de '.$data['name'].' ('.afftaille($data['size']).')');
			doc_refresh($datamodule['doc']);
      }
		else trigger_error("upload rate", E_USER_WARNING);
    break;

   case 'cmd_supprconf' :
    if(!empty($data))
      {
      $datamodule['fics'] = $data;
      $datamodule['confirmation'] = 1;
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['fics']))
      {
      reset($datamodule['fics']);
      while(list($val,)=each($datamodule['fics']))
        {
        msg_ajout('suppression de "'.Fichier_designation($val).'"');
        Fichier_supprimer($val);
        }
			doc_refresh($datamodule['doc']);
      unset($datamodule['fics']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

if(isset($HTTP_POST_VARS[IDENT_EDIT_FIC]) && isset($HTTP_POST_VARS['FIC_NOM']))
  {
  $fic_visible = isset($HTTP_POST_VARS['FIC_VISIBLE']) ? $HTTP_POST_VARS['FIC_VISIBLE'] : array();
  $fic_vislang = isset($HTTP_POST_VARS['FIC_VISLANG']) ? $HTTP_POST_VARS['FIC_VISLANG'] : array();
 
  $fic_nom = $HTTP_POST_VARS['FIC_NOM'];
  $fic_titre = $HTTP_POST_VARS['FIC_TITRE'];

	doc_refresh($datamodule['doc']);
  reset($fic_nom);
  while(list($key, $val) = each($fic_nom))
    {
    $visible = isset($fic_visible[$key]) ? 1 : 0;
    NewQuery('UPDATE ratfichiers SET
      fic_designation = "'.TxtSql($val).'",
      fic_visible = '.$visible.' WHERE fic_id = '.$key);
    $vislang = isset($fic_vislang[$key]) ? 1 : 0;
    NewQuery('UPDATE ratlnk_ficlang SET
      fil_titre = "'.TxtSql($fic_titre[$key]).'",
      fil_visible = '.$vislang.' WHERE fic_id = '.$key.' AND lang_id='.Langue_id($Session['langue_edition']));
    }
  }

?>