<?

Librairie('docliens');
Librairie('documents');

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
  'cmd_listdocs',
  'cmd_editdoc',
  'cmd_fichiers',
  'cmd_ajouter',
  'cmd_supprconf',
  'cmd_supprimer',
  'cmd_annuler',
  'cmd_pages');

/**************************************************************************************
  commandes
**************************************************************************************/
global $Session, $datamodule, $HTTP_POST_VARS;

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, '', 'dlis');
if(!empty($data)) $datamodule['dlis'] = $data;

switch($cmd)
  {
  case 'cmd_rien' : break;

  case 'cmd_ajouter' :
    NewQuery('INSERT INTO ratdocliens(doc_id, dli_ident, dli_visible) VALUES('.$datamodule['doc'].', "'.TxtSql('Nouveau lien').'", 1)');
		doc_refresh($datamodule['doc']);
    break;

  case 'cmd_listdocs' :
    $Session['mode'] = 'principal';
    break;

  case 'cmd_editdoc' :
    $Session['mode'] = 'edit_main';
    break;

  case 'cmd_fichiers' :
    $Session['mode'] = 'fichiers';
    break;

  case 'cmd_pages' :
    $Session['mode'] = 'pages';
    break;

  case 'cmd_supprconf' :
    if(!empty($data))
      {
      $datamodule['dlis'] = $data;
      $datamodule['confirmation'] = 1;
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['dlis']))
      {
      reset($datamodule['dlis']);
      while(list($val,)=each($datamodule['dlis']))
        {
        msg_ajout('suppression de "'.dli_designation($val).'"'); //TODO TRADUCTION
        dli_supprimer($val);
        }
      unset($datamodule['dlis']);
			doc_refresh($datamodule['doc']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

/**************************************************************************************
  gestion du filtre
**************************************************************************************/

if(isset($HTTP_POST_VARS[IDENT_EDIT_DLI]) && isset($HTTP_POST_VARS['DLI_NOM']))
  {
  $visibles = @$HTTP_POST_VARS['DLI_VISIBLE'];
  $vislangs = @$HTTP_POST_VARS['DLI_VISLANG'];
  $nom = $HTTP_POST_VARS['DLI_NOM'];
  $titre = $HTTP_POST_VARS['DLI_TITRE'];
  $doclie = $HTTP_POST_VARS['DLI_DOCLIE'];
  $url = $HTTP_POST_VARS['DLI_URL'];

  reset($nom);
  while(list($key, $val) = each($nom))
    {
    $visible = isset($visibles[$key]) ? 1 : 0;
    NewQuery('UPDATE ratdocliens SET
      dli_liendoc = '.$doclie[$key].',
      dli_adresse = "'.TxtSql($url[$key]).'",
      dli_ident = "'.TxtSql($val).'",
      dli_visible = '.$visible.' WHERE dli_id = '.$key);
    $vislang = isset($vislangs[$key]) ? 1 : 0;
    NewQuery('UPDATE ratlnk_dlilang SET
      dll_titre = "'.TxtSql($titre[$key]).'",
      dll_visible = '.$vislang.' WHERE dli_id = '.$key.' AND lang_id='.Langue_id($Session['langue_edition']));
    }
  }

?>