<?

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
  //'cmd_ajouter',
  'cmd_supprconf',
  'cmd_supprimer',
  'cmd_annuler',
  'cmd_editer',
  'cmd_montrer',
  'cmd_cacher',
  'cmd_deplacer',
  'cmd_ajouter',
  'cmd_dossiers');

/**************************************************************************************
  commandes
**************************************************************************************/
global $Session, $datamodule, $HTTP_POST_VARS;
Librairie('documents');
Librairie('dossiers');

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, 'doc', 'docs');

if(isset($HTTP_POST_VARS['clean_docs'])) unset($datamodule['docs']);
if(isset($datamodule['doc'])) unset($datamodule['doc']);

switch($cmd)
  {
  case 'cmd_rien' : break;

  case 'cmd_dossiers' :
    $Session['mode'] = 'dossiers';
    break;

  case 'cmd_editer' :
    $Session['mode'] = 'edit_main';
    $datamodule['doc'] = $data;
		$datamodule['pag'] = 0;
    unset($datamodule['docs']);
    break;

  case 'cmd_ajouter' :
    $Session['mode'] = 'edit_main';
    $datamodule['doc'] = doc_ajout(module_id($Session['module']), $Session['id_personne'],
      dossier_premier($Session['site']));
    unset($datamodule['docs']);
    break;

  case 'cmd_supprconf' :
    if(!empty($data))
      {
      $datamodule['docs'] = $data;
      $datamodule['confirmation'] = 1;
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['docs']))
      {
      reset($datamodule['docs']);
      while(list($val,)=each($datamodule['docs']))
        {
        msg_ajout('suppression de "'.doc_designation($val).'"'); //TODO TRADUCTION
        doc_supprimer($val);
        }
      unset($datamodule['docs']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;

  case 'cmd_cacher' :
    if(!empty($data))
      {
      $datamodule['docs'] = $data;
      while(list($key,) = each($data)) doc_visible($key, 0);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_montrer' :
    if(!empty($data))
      {
      $datamodule['docs'] = $data;
      while(list($key,) = each($data)) 
				{
				doc_visible($key, 1);
				dol_visible($key, $Session['langue_edition'], 1);
				}
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_deplacer' :
    if(!empty($data))
      {
      $datamodule['docs'] = $data;
      while(list($key,) = each($data)) doc_deplacer($key, $HTTP_POST_VARS['change_dossier']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

/**************************************************************************************
  gestion du filtre
**************************************************************************************/

function FromPost($valeur)
  {
  global $HTTP_POST_VARS, $datamodule;
  if(isset($HTTP_POST_VARS[$valeur])) $datamodule[$valeur] = $HTTP_POST_VARS[$valeur];
  }

function FromGet($valeur)
  {
  global $HTTP_GET_VARS, $datamodule;
  if(isset($HTTP_GET_VARS[$valeur])) $datamodule[$valeur] = $HTTP_GET_VARS[$valeur];
  }

if(isset($HTTP_POST_VARS['nofiltre']))
  {
  unset($datamodule['filtre_auteur']);
  $datamodule['filtre_module'] = 'totalvide';
  unset($datamodule['filtre_motsclefs']);
  unset($datamodule['filtre_dossier']);
	unset($datamodule['filtre_liens']);
	unset($datamodule['filtre_fichiers']);
	unset($datamodule['filtre_pages']);
	unset($datamodule['filtre_documents']);
	unset($datamodule['filtre_systeme']);
  }
elseif(isset($HTTP_POST_VARS['filtre_motsclefs']))
  {
  FromPost('filtre_auteur');
  FromPost('filtre_motsclefs');
  FromPost('filtre_module');
  FromPost('filtre_dossier');
	unset($datamodule['filtre_systeme']);
	FromPost('filtre_systeme');
	unset($datamodule['filtre_liens']);
	FromPost('filtre_liens');
	unset($datamodule['filtre_fichiers']);
	FromPost('filtre_fichiers');
	unset($datamodule['filtre_pages']);
	FromPost('filtre_pages');
	unset($datamodule['filtre_documents']);
	FromPost('filtre_documents');
  }
FromGet('sort');
FromGet('sens');
if(!isset($datamodule['filtre_module'])) $datamodule['filtre_module'] = 'totalvide';

?>