<?

global $module_ecran, $Session, $datamodule, $GS, $HGS, $HTTP_POST_VARS;

function GetItems()
  {
  global $datamodule;
  $result = array();

  if(!empty($datamodule['docs']))
    {
    reset($datamodule['docs']);
    while(list($val,)=each($datamodule['docs'])) $result[] = doc_designation($val);
    }
  else trigger_error("datamodule['docs'] vide", E_USER_WARNING);

  return $result;
  }
	
function ExtractID($sql, $tableau)
	{
	$req = NewQuery($sql);
	$filtre = array();
	while($req->next_record()) $filtre[$req->f('doc_id')]=$req->f('doc_id');
	if(is_array($tableau)) return array_intersect($tableau, $filtre);
	else return $filtre;
	}

/**************************************************************************************
  affichage
**************************************************************************************/
if(isset($datamodule['confirmation']))
  {
  $tab = GetItems();
  if(count($tab)>1)
    $module_ecran = EcranConfirmation('Voulez vous supprimer ces documents?', $tab, 'cmd_supprimer', 'cmd_annuler');
  else $module_ecran = EcranConfirmation('Voulez vous supprimer ce document?', $tab, 'cmd_supprimer', 'cmd_annuler');
  }
else
  {
  if(!isset($datamodule['filtre_module'])) $datamodule['filtre_module'] = 'totalvide';
	if(!isset($datamodule['filtre_auteur'])) $datamodule['filtre_auteur'] = '';
	if(!isset($datamodule['filtre_motsclefs'])) $datamodule['filtre_motsclefs'] = '';
	if(!isset($datamodule['filtre_dossier'])) $datamodule['filtre_dossier'] = '';

  $tpl = ModeleAdmin('liste.html', 'documents');
  $tpl->assign('HIDDEN', '<input type="hidden" name="clean_docs" value="1">'.$HGS);
  $tpl->assign('SID', $GS);

  /**************************************************************************************
    affichage boite de filtre
  **************************************************************************************/
  $tpl->assign('LISTE_AUTEURS', Sql2Options('
    SELECT DISTINCT pers.pers_id AS chp1, pers.pers_prenom AS chp2, pers.pers_nom AS chp3
    FROM ratpersonnes AS pers
      INNER JOIN ratlnk_grppers AS gpe ON gpe.pers_id=pers.pers_id
      INNER JOIN ratlnk_sitegroupe as sig ON sig.grp_id=gpe.grp_id AND sig.sit_id='.$Session['site'].'
    ORDER BY pers_prenom, pers_nom', VorN($datamodule['filtre_auteur'])));

  $sqlmodules = '
    SELECT DISTINCT mod.mod_id AS chp1, mol.mol_texte AS chp2
    FROM ratmodules AS mod
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$Session['langue_edition'].'"
      INNER JOIN ratlnk_grppers AS gpe ON gpe.pers_id='.$Session['id_personne'].'
      INNER JOIN ratlnk_modlang AS mol ON mol.mod_id=mod.mod_id AND mol.lang_id=lang.lang_id
      INNER JOIN ratlnk_modgrp AS mog ON mog.mod_id=mod.mod_id AND mog.grp_id=gpe.grp_id
    WHERE mod.mod_type=4
    ORDER BY mol.mol_texte';
  $sanslien='<option value="totalvide"'.($datamodule['filtre_module']=='totalvide' ? ' selected' : '').'></option>'.
    '<option value="0"'.(@$datamodule['filtre_module']=='0' ? ' selected': '').'>Sans lien</option>';

  $tpl->assign('LISTE_MODULESFILTRE', $sanslien.Sql2Options($sqlmodules, VorN($datamodule['filtre_module'])));
  $tpl->assign('LISTE_MODULES', Sql2Options($sqlmodules, VorN($datamodule['filtre_module'])));

  $tpl->assign('LISTE_DOSSIERS', Sql2Options('
    SELECT dos.dos_id AS chp1, dos.dos_nom AS chp2 FROM ratdossiers AS dos
    INNER JOIN ratlnk_dossite AS dsi ON dsi.dos_id=dos.dos_id AND dsi.sit_id='.$Session['site'],
    VorN($datamodule['filtre_dossier'])));

  $tpl->assign('FILTRE', $datamodule['filtre_motsclefs']);
	$tpl->assign('ST_LIENS', isset($datamodule['filtre_liens']) ? ' checked' : '');
	$tpl->assign('ST_FICHIERS', isset($datamodule['filtre_fichiers']) ? ' checked' : '');
	$tpl->assign('ST_PAGES', isset($datamodule['filtre_pages']) ? ' checked' : '');
	$tpl->assign('ST_SYSTEME', isset($datamodule['filtre_systeme']) ? ' checked' : '');
	$tpl->assign('ST_DOCUMENTS', isset($datamodule['filtre_documents']) ? ' checked' : '');

  /**************************************************************************************
    affichage liste des documents
  **************************************************************************************/

  $corresColonnes = array(
    'titre' => 'dos.dos_nom, doc.doc_designation',
    'auteur' => 'doc.per_id',
    'module' => 'mol.mol_texte',
    'maj' => 'doc.doc_modification');
  $corresSens = array('up' => 'ASC', 'dn' => 'DESC');

  if(!empty($datamodule['sort']))
  $clause_trier=' ORDER BY '.$corresColonnes[$datamodule['sort']].' '.$corresSens[$datamodule['sens']];
  else $clause_trier='';
			
	$sqlLiens = '
		select distinct dli.doc_id
		from ratdocliens as dli
		  inner join ratdocuments as doc on doc.doc_id=dli.doc_id
  		inner join ratlnk_dossite as dst on dst.dos_id=doc.dos_id and dst.sit_id='.$Session['site'].'
  		left outer join ratlnk_pagdoclien as pdl on pdl.dli_id=dli.dli_id
    group by dli.doc_id, dli.dli_id
    having count(pdl.pag_id)=0';
		
	$sqlFichiers = '
    select distinct fic.doc_id
    from ratfichiers as fic
      inner join ratdocuments as doc on doc.doc_id=fic.doc_id
      inner join ratlnk_dossite as dst on dst.dos_id=doc.dos_id and dst.sit_id='.$Session['site'].'
      left outer join ratlnk_pagfichier as pfi on pfi.fic_id=fic.fic_id
    group by fic.doc_id, fic.fic_id
    having count(pfi.pag_id)=0';
		
	$sqlPages = '
    select distinct pag.doc_id
    from ratpages as pag
			inner join ratlangues AS lang ON lang.lang_abrege="'.$Session['langue_edition'].'"
      inner join ratlnk_paglang as pal on (pag.pag_visible=0 or pal.pal_visible=0) and pal.pag_id=pag.pag_id and pal.lang_id=lang.lang_id
      inner join ratdocuments as doc on doc.doc_id=pag.doc_id
    	inner join ratlnk_dossite as dst on dst.dos_id=doc.dos_id and dst.sit_id='.$Session['site'].'';
			
	$sqlDocuments = '
		SELECT DISTINCT doc.doc_id
		FROM ratdocuments AS doc
    	INNER JOIN ratlnk_dossite AS dst on dst.dos_id=doc.dos_id and dst.sit_id='.$Session['site'].'
			LEFT OUTER JOIN ratlnk_rubdoc AS rdo ON rdo.doc_id=doc.doc_id
		GROUP BY doc.doc_id
		HAVING COUNT(rdo.rub_id)=0';
	
  $id_filtre = 0;	
  if(isset($datamodule['filtre_liens'])) $id_filtre = ExtractID($sqlLiens, $id_filtre);
  if(isset($datamodule['filtre_fichiers'])) $id_filtre = ExtractID($sqlFichiers, $id_filtre);
  if(isset($datamodule['filtre_pages'])) $id_filtre = ExtractID($sqlPages, $id_filtre);
  if(isset($datamodule['filtre_documents'])) $id_filtre = ExtractID($sqlDocuments, $id_filtre);
	
  $clause_filtrer="";
  if(!empty($datamodule['filtre_auteur']))
    $clause_filtrer.=' AND doc.pers_id='.$datamodule['filtre_auteur'];
  if(@$datamodule['filtre_module']!='totalvide')
    $clause_filtrer.=' AND doc.mod_id='.Vor0(@$datamodule['filtre_module']);
  if(!empty($datamodule['filtre_dossier']))
    $clause_filtrer .= ' AND doc.dos_id='.Vor0($datamodule['filtre_dossier']);
  if(empty($datamodule['filtre_systeme'])) $clause_filtrer .= ' AND (per.pers_id<>'.Personne_systeme().')';
  if(!empty($datamodule['filtre_motsclefs']))
    {
    $tab = explode(' ', $datamodule['filtre_motsclefs']);
    for($i=0, $max=count($tab); $i<$max; $i++)
      $clause_filtrer.=' and (dol.dol_titre LIKE "%'.$tab[$i].'%" OR doc.doc_designation LIKE "%'.$tab[$i].'%")';
    }
	if($id_filtre!=0) 
		if(empty($id_filtre))	$clause_filtrer .= ' and (doc.doc_id IN (0))';
		else $clause_filtrer .= ' and (doc.doc_id IN ('.implode(',', $id_filtre).'))';
		
  $req = NewQuery('
    SELECT
      doc.doc_id, doc.doc_designation, doc.doc_modification, doc.doc_visible,
      dol.doc_id AS dol_id, dol.dol_titre, dol.dol_visible,
      mol.mol_texte,
      per.pers_prenom, per.pers_nom,
      dos.dos_nom
    FROM ratdocuments AS doc
      INNER JOIN ratlangues AS lan ON lan.lang_abrege="'.$Session['langue_edition'].'"
      INNER JOIN ratpersonnes AS per ON per.pers_id=doc.pers_id
      INNER JOIN ratdossiers AS dos ON dos.dos_id=doc.dos_id
			INNER JOIN ratlnk_dossite AS dsi ON dsi.dos_id=dos.dos_id AND dsi.sit_id='.$Session['site'].'
      INNER JOIN ratlnk_modlang AS mol ON mol.mod_id=doc.mod_id AND mol.lang_id=lan.lang_id
      LEFT JOIN ratlnk_doclang AS dol ON dol.lang_id=lan.lang_id AND dol.doc_id=doc.doc_id
    WHERE (0=0) '.$clause_filtrer.$clause_trier);

  if($req->next_record()) do
    {
    $tpl->assign('STATE', isset($datamodule['docs'][$req->f('doc_id')]) ? ' checked' : '');
    $tpl->assign('IDDOC', $req->f('doc_id'));
    $titre = TxtHTML($req->f('dos_nom')).'&nbsp;\\&nbsp;'.TxtHTML($req->f('doc_designation'));
    if($req->f('dol_id')=='') $titre .= ' (non traduit)';
    else $titre .= ' "'.TxtHTML($req->f('dol_titre')).'"';
    $tpl->assign('TITRE', $titre);
    $tpl->assign('AUTEUR', ChaineFrm(TxtHTML($req->f('pers_prenom')).'&nbsp;'.TxtHTML($req->f('pers_nom'))));
    $tpl->assign('MODULE', ChaineFrm(TxtHTML($req->f('mol_texte'))));
    $tpl->assign('MAJ', date_m2p($req->f('doc_modification')));
    $tpl->assign('COULEUR', $req->f('doc_visible') && $req->f('dol_visible') ? '#CCCCCC' : '#CCFFFF');
    $tpl->parse('MAIN.LIGNE');
    }
    while($req->next_record());
  else $tpl->parse('MAIN.LISTEVIDE');

  /**************************************************************************************
    fin
  **************************************************************************************/
  $tpl->parse('MAIN');
  $module_ecran = $tpl->text('MAIN');
  }

?>