<?php

global $msg_gene, $Session, $datamodule;

Librairie('rubriques');
Librairie('utilitaires');
Librairie('rawdata');
Librairie('documents');
Librairie('docliens');

if(!defined('DOCUMENTS_REGENERE')) {
define('DOCUMENTS_REGENERE', 1);

function page_sommairebloc($doc, $numpage, $pag_nb, $langue)
//gnration du bloc sommaire si la page en comporte un
  {
	$tpl = ModeleSite('sommaire.html', 'documents');		
	
  $tpl->assign('DOC_ID', $doc['id'].'');
  $tpl->assign('PAG_NUM', '1');
  $tpl->assign('PAG_TITRE', TxtHTML('Sommaire'));
  $tpl->parse('MAIN.LIGNE');   

	reset($doc['pages']);
	while(list(, $val)=each($doc['pages'])) if($val['langue']==$langue)
		{
		$tpl->assign('DOC_ID', $doc['id'].'');
		$tpl->assign('PAG_NUM', ($val['pos']+1).'');
		$tpl->assign('PAG_TITRE', TxtHTML($val['titre']));
		$tpl->parse('MAIN.LIGNE');   
		}

  $tpl->parse('MAIN');
  return page_generebloc($doc, $numpage, $pag_nb, 0, $langue, $tpl->text('MAIN'));
  }
	
function ChercheTitrePage($doc, $pag_num, $langue)
//recherche du titre de la page dans les donnes
	{
	if($doc['sommaire']==1 and $pag_num==1)
		return 'Sommaire';
	else
		{
  	reset($doc['pages']);
  	if($doc['sommaire']==1) $som = 1; else $som = 0;
  	$trouve = false;
  	while(!$trouve and list($key, $val)=each($doc['pages'])) $trouve = (($val['pos']+$som)==$pag_num and $val['langue']==$langue);
  	if($trouve) return $val['titre']; else 
			{
			trigger_error("page non trouvee (doc ".$doc['id']." pag_num $pag_num langue $langue)", E_USER_WARNING);
			return '';
			}
		}
	}

function page_generebloc($doc, $pag_num, $pag_nb, $pag_id, $langue, $valeur='')
//gnration du bloc page en fonction des paramtres
  {
	global $Session, $datamodule;
	
  $tpl = ModeleSite('squelette.html', 'documents');

  if($doc['navigation']==1) //y'a t'il la navigation
    {
    $tpl->assign('DOC_ID', $doc['id']);
    if($doc['sommaire']==1 and $pag_num!=1)
      {
      $tpl->assign('S_PAG_ID', '1');
      $tpl->parse('MAIN.NAVIGATION.SOMMAIRE');
      }
    if($pag_num!=1)
      {
			$tpl->assign('PAG_PRECEDENTE', ChercheTitrePage($doc, $pag_num-1, $langue));
      $tpl->assign('N_PAG_ID', ($pag_num-1).'');
      $tpl->parse('MAIN.NAVIGATION.PRE');
      }
    if($pag_num<$pag_nb)
      {
			$tpl->assign('PAG_SUIVANTE', ChercheTitrePage($doc, $pag_num+1, $langue));
      $tpl->assign('P_PAG_ID', ($pag_num+1).'');
      $tpl->parse('MAIN.NAVIGATION.POST');
      }
    $tpl->assign('PAG_NUM', $pag_num.'');
    $tpl->assign('PAG_NB', $pag_nb.'');
    $tpl->parse('MAIN.NAVIGATION');
    }

  if($doc['entete']==1) //y'a t'il un en-tete?
    {
    $tpl->assign('TITRE', TxtHTML($doc['titre'][$langue]));
    $tpl->assign('PAG_TITRE', TxtHTML(ChercheTitrePage($doc, $pag_num, $langue)));
		if(ChercheTitrePage($doc, $pag_num, $langue)!='' && $pag_nb>1) $tpl->parse('MAIN.ENTETE.TITRE');
    $tpl->assign('DATE', TxtHTML($doc['date']));
    $tpl->assign('AUTEUR', TxtHTML($doc['prenom']).''.TxtHTML($doc['nom']));
    $tpl->assign('DESCRIPT', TxtHTML($doc['description'][$langue]));
    $tpl->parse('MAIN.ENTETE');
    }

  if($valeur=='') $texte = $doc['textes'][$pag_id][$langue]; else $texte = $valeur;
  if(get_magic_quotes_gpc()==1) $texte = stripslashes($texte);
	if($doc['sommaire']==1) 
		{	if($valeur=='' && $doc['pages'][$pag_num-1]['eol']==1) $texte = nl2br($texte); }
	elseif($valeur=='' && $doc['pages'][$pag_num]['eol']==1) $texte = nl2br($texte);
	$tpl->assign('TEXTE', $texte); 
	
	//gestion des fichiers
	$req = NewQuery('
    SELECT fic.fic_id, fic.fic_designation, fic.fic_taille, fil.fil_titre
		FROM ratfichiers AS fic
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$langue.'"
			INNER JOIN ratlnk_ficlang AS fil ON fic.fic_id=fil.fic_id AND fil.lang_id=lang.lang_id
			INNER JOIN ratlnk_pagfichier AS pfi ON pfi.fic_id=fic.fic_id AND pfi.pag_id='.$pag_id.'
  	WHERE fic.fic_visible=1 AND fil.fil_visible=1');
		
	if($req->next_record())
		{
		do
			{
			$tpl->assign('LIEN', BASEREF.'get.php?site='.Site_nom($Session['site']).'&doc='.$doc['id'].
				'&fic='.$req->f('fic_id').'&nom='.$req->f('fic_designation'));
			$tpl->assign('TITRE', TxtHTML($req->f('fil_titre')));
			$tpl->assign('NOM', TxtHTML($req->f('fic_designation')));
			$tpl->assign('TAILLE', afftaille($req->f('fic_taille')));
			$tpl->parse('MAIN.FICHIERS.FICHIER');
			}
		while($req->next_record());
		$tpl->parse('MAIN.FICHIERS');
		}

	//gestion des liens
	$req = NewQuery('
    SELECT dli.dli_id, dli.dli_liendoc, dli.dli_adresse, dll.dll_titre, dll.dll_description
		FROM ratdocliens AS dli
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$langue.'"
			INNER JOIN ratlnk_dlilang AS dll ON dli.dli_id=dll.dli_id AND dll.lang_id=lang.lang_id
			INNER JOIN ratlnk_pagdoclien AS pdl ON pdl.dli_id=dli.dli_id AND pdl.pag_id='.$pag_id.'
  	WHERE dli.dli_visible=1 AND dll.dll_visible=1');
		
	if($req->next_record())
		{
		do
			{
			$target = $req->f('dli_liendoc')=='' ? ' target="_blank"' : '';
			$tpl->assign('LIEN', 'href="'.Doclien_calcul($req->f('dli_liendoc'), $req->f('dli_adresse')).'"'.$target);
			$tpl->assign('TITRE', TxtHTML($req->f('dll_titre')));
			$tpl->assign('DESCRIPTION', TxtHTML($req->f('dll_description')));
			$tpl->parse('MAIN.LIENS.LIEN');
			}
		while($req->next_record());
		$tpl->parse('MAIN.LIENS');
		}

  $tpl->parse('MAIN');
  return $tpl->text('MAIN');
  }

function GenereDocument($doc)
  //gnration des pages
  {
  global $msg_gene;

  $msg_gene[] = 'DOCUMENTS: gnration document '.$doc['designation'];
  //NewQuery(
  if($doc['sommaire']==1)
    {
    reset($doc['langues']);
    while(list($key,)=each($doc['langues'])) blocSauve('documents', doc_base($doc['id'], 1, $key),
      page_sommairebloc($doc, 1, count($doc['pages_uniques'])+1, $key));
    $pagenum = 1;
    }
  else $pagenum = 0;

  reset($doc['pages']);
  while(list(,$val)=each($doc['pages']))
    {
    $nom = doc_base($doc['id'], $val['pos']+$pagenum, $val['langue']);
    blocSauve('documents', $nom, page_generebloc($doc, $val['pos']+$pagenum, count($doc['pages_uniques'])+$pagenum, $val['id'], $val['langue']));
    }
	rubdoc_refresh($doc['id']);
	$edito = getData('accueilvitrine', 'edito', 0);
	if($edito!=0 and $edito == $doc['id']) setData('accueilvitrine', 'refresh', 1);
  }

} //fin !defined('ERREURSVITRINE_REGENERE')


$req = NewQuery('
  select distinct
    doc.doc_id, doc.doc_designation, doc.doc_entete, doc.doc_navigation, doc.doc_sommaire, doc.doc_modification,
    dol.dol_titre, dol.dol_motsclefs, dol.dol_description,
    pag.pag_id, pag.pag_position, pag.pag_eol, pal.pal_titre, pal.pal_texte, lang.lang_abrege,
    pers.pers_prenom, pers.pers_nom
  from ratdocuments as doc
    inner join ratpages as pag on pag.pag_visible and pag.doc_id=doc.doc_id
    inner join ratlnk_doclang as dol on dol.dol_visible=1 and dol.doc_id=doc.doc_id
    inner join ratlnk_paglang as pal on pal.pal_visible=1 and pal.lang_id=dol.lang_id
      and pag.pag_id=pal.pag_id
    inner join ratlangues as lang on lang.lang_id=dol.lang_id
    inner join ratlnk_dossite as dsi on dsi.sit_id='.$Session['site'].' and doc.dos_id=dsi.dos_id
    left outer join ratpersonnes as pers on pers.pers_id=doc.pers_id
  where doc.doc_refresh=1 and doc.doc_visible=1 order by doc.doc_id, pag.pag_position, lang.lang_id');

$doc['id'] = -1;

while($req->next_record())
  {
  //test du changement de document
  if($doc['id']!=$req->f('doc_id'))
    {
    if(!empty($doc['pages'])) 
			{
			GenereDocument($doc);
			NewQuery('UPDATE ratdocuments SET doc_refresh=0 WHERE doc_id='.$doc['id']);
			}

    //raz des infos et stockage
    $doc['id']=$req->f('doc_id');
    $compte = 0;
    $doc['designation'] = $req->f('doc_designation');
    $doc['entete'] = $req->f('doc_entete');
    $doc['navigation'] = $req->f('doc_navigation');
    $doc['sommaire'] = $req->f('doc_sommaire');
    $doc['prenom'] = $req->f('pers_prenom');
    $doc['nom'] = $req->f('pers_nom');
    $doc['date'] = date_m2p($req->f('doc_modification'));
    $doc['pages'] = array();
    $doc['pages_uniques'] = array();
    $doc['langues'] = array();
    }

  $doc['titre'][$req->f('lang_abrege')] = $req->f('dol_titre');
  $doc['motsclefs'][$req->f('lang_abrege')] = $req->f('dol_motsclefs');
  $doc['description'][$req->f('lang_abrege')] = $req->f('dol_description');
		
  //chargement de toutes les pages dans un tableau
  $compte++;
  $doc['pages'][$compte]['id'] = $req->f('pag_id');
	$doc['pages'][$compte]['eol'] = $req->f('pag_eol');
	$doc['pages'][$compte]['titre'] = $req->f('pal_titre');
  $doc['pages'][$compte]['pos'] = $req->f('pag_position');
  $doc['textes'][$req->f('pag_id')][$req->f('lang_abrege')] = $req->f('pal_texte');
  $doc['pages'][$compte]['langue'] = $req->f('lang_abrege');
  $doc['pages_uniques'][$req->f('pag_id')] = $compte;
  $doc['langues'][$req->f('lang_abrege')] = 1;
  }
if(!empty($doc['pages'])) 
	{
	GenereDocument($doc);
	NewQuery('UPDATE ratdocuments SET doc_refresh=0 WHERE doc_id='.$doc['id']);
	}

?>