<?
global $msg_gene, $Session;

Librairie('rawdata');
Classe('documents');
Librairie('utilitaires');
Librairie('dossiers');
Librairie('personnes');

if(!defined('LIGUE_REGENERE')) {
define('LIGUE_REGENERE', 1);

$idclub = 'NULL';
$clubs = array();

$idcat = 'NULL';
$cats = array();
$fichcats = array();
$nbscorescat = array();
$docucats = array();
$nbselected = array();

$nbarchers = array();
$scores = array();
$yaretard = false;
$tpl = NULL;
$dateclassement = '';

$ident_liste = 0;
$ident_cats = array();

$raz = 0;

global $idcat, $idclub, $clubs, $scores, $dateclassement, $fichcats, $catofarcher, $nbscorescat,
    $nbarchers, $docucats, $raz, $nbselected, $page, $cats;

function classement_generepage($saison, $data, $titre, &$doc, &$page)
  {
	$pag = $doc->Page($page);
	$pag->Ident($titre);
	$pag->Visible(true);
	$pag->TexteCommun(false);
	$pag->VisLang(true);
	$pag->Titre($titre); //todo traduction
	$pag->Description('');
	$pag->Texte($data);	
	$pag->Sauver(); 
	
	$page++;
  }

/**************************************************************************************
  Handlers de balises
**************************************************************************************/
function startElement($parser, $name, $attrs)
  {
  global $idcat, $idclub, $clubs, $scores, $dateclassement, $fichcats, $catofarcher, $nbscorescat,
    $nbarchers, $docucats, $raz, $nbselected;

  if($name=='CLASSEMENT') $dateclassement=$attrs['DATE'];
  elseif($name=='COMMENT') xml_set_character_data_handler($parser, "dataCommentHandler");
  elseif($name=='RETARD') xml_set_character_data_handler($parser, "dataRetardHandler");
  elseif($name=='CAT')
    {
    $idcat = $attrs['ID'];
    if($raz) setData('drp_done_'.$idcat, '0');
    if(getData('drp_done_'.$idcat, '0')==0)
      {
      xml_set_character_data_handler($parser, "dataCatHandler");
      $nbscorescat[$idcat] = $attrs['NBSCORES'];
      $nbselected[$idcat] = $attrs['SELECTED'];
      $nbarchers[$idcat] = 0;
      $fichcats[$idcat] = ModeleSite('archers.html', 'ligue');
      }
    }
  elseif($name=='CLUB')
    {
    xml_set_character_data_handler($parser, "dataClubHandler");
    $idclub = $attrs['ID'];
    }
  elseif($name=='ARCHER')
    {
    if(getData('drp_done_'.$idcat, '0')==0)
      {
      $catofarcher = $attrs['CAT'];
      $nbarchers[$catofarcher]++;

      if ($nbarchers[$catofarcher]<=$nbselected[$catofarcher])
        $fichcats[$attrs['CAT']]->assign('COLOR', '#CCCCCC');
      else $fichcats[$attrs['CAT']]->assign('COLOR', '');
      $fichcats[$attrs['CAT']]->assign('PLACE', $nbarchers[$catofarcher].'');
      $fichcats[$attrs['CAT']]->assign('ARCHER', $attrs['NOM']);
      $fichcats[$attrs['CAT']]->assign('CLUB', $clubs[$attrs['CLUB']]);
      $fichcats[$attrs['CAT']]->assign('MOYENNE', $attrs['MOY']);
      $scores = explode('-', $attrs['SCORES']);
      xml_set_element_handler($parser, "startElement", "endArcherElement");
      }
    }
  }

function endElement($parser, $name)
  {
  xml_set_character_data_handler($parser, 'donothing');
  }

function endArcherElement($parser, $name)
  {
  global $catofarcher, $fichcats, $scores;

  if($name=='ARCHER')
    {
    $fichcats[$catofarcher]->assign('SCORE', implode('&nbsp/&nbsp;', $scores));
    $fichcats[$catofarcher]->parse('MAIN.ARCHER');
    xml_set_element_handler($parser, "startElement", "endElement");
    }
  else xml_set_character_data_handler($parser, 'donothing');
  }

/**************************************************************************************
  Handlers de data
**************************************************************************************/

function donothing($parser, $data)
  {
  }

function dataRetardHandler($parser, $data)
  {
  global $yaretard, $tpl;

  $yaretard = true;
  $tpl->assign('NOMRETARD', $data);
  $tpl->parse('MAIN.RETARDS.LIGNERETARD');
  }

function dataCommentHandler($parser, $data)
  {
  global $tpl;

  $tpl->assign('COMMENTS', $data);
  }

function dataCatHandler($parser, $data)
  {
  global $cats, $idcat, $tpl, $docucats;

  $cats[$idcat]=$data;
  $tpl->assign('NOMCAT', $data);
  $tpl->assign('LIENCAT', '?doc='.$docucats[$idcat]); //TODO
  $tpl->parse('MAIN.CATEGORIE');
  }

function dataClubHandler($parser, $data)
  {
  global $clubs, $idclub;

  $clubs[$idclub]=$data;
  }

} //fin !defined('ERREURSVITRINE_REGENERE')

//si le chemin de donnes n'existe pas, le module ne doit pas fontionner
if(!is_dir(CHEMIN_DONNEES.'ligue')) return '';

$dir = dir(CHEMIN_DONNEES.'ligue');
while($fichier = $dir->read()) if(preg_match('/^classement[.]([a-zA-Z0-9]+)[.]xml/i', $fichier, $res)!=false
	and getData('ligue', 'classement.'.$res[1].'.refresh', 1)==1)
	{
	$saison = $res[1];
		
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElement", "endElement");
	$cheminxml = CHEMIN_DONNEES.'ligue/'.$fichier;
	if (!($fp = fopen($cheminxml, "r"))) 
		trigger_error("XML error: ouverture du fichier impossible <fichier>".TxtXml($cheminxml)."</fichier>", E_USER_WARNING);
	
  while ($data = fread($fp, 4096)) if (!xml_parse($xml_parser, $data, false))
    trigger_error("XML error: ".TxtXml(xml_error_string(xml_get_error_code($xml_parser)))." at line ".xml_get_current_line_number($xml_parser), E_USER_WARNING);
	
	xml_parser_free($xml_parser);
	if($yaretard) $tpl->parse('MAIN.RETARDS');

	$document = getData('ligue', 'classement.'.$saison.'.document', 0);
  if($document==0)
    { //gestion pour la cration ventuelle d'un document
		$doc = new CClassDoc(0, 1);
		$doc->Personne(Personne_systeme());
		$doc->Module(module_id('ligue'));
		$doc->Visible(true);
		$doc->EnTete(true);
		$doc->Navigation(true);
		$doc->Sommaire(true);
		$doc->Dossier(dos_systeme($Session['site']));
		$doc->Designation('Classement '.$saison);
    }
  else $doc = new CClassDoc($document, 1);

	//sauve le document pour la langue
  $doc->Titre('Classement '.$saison); //todo traduction
  $doc->MotsClefs('classementt');
  $doc->Description("Le classement tabli sur les concours de la saison");
  $doc->VisLang(true);
  $doc->Sauver();
	if($document==0) setData('ligue', 'classement.'.$saison.'.document', $doc->id);

	$page = 1;	
	while(list($key, $val)=each($fichcats))
	  {
	  $val->parse('MAIN');
		classement_generepage($saison, $val->text('MAIN'), $cats[$key], $doc, $page);
	  }
	$msg_gene[] = 'LIGUE: Gnration du classement de la saison '.$saison;
	setData('ligue', 'classement.'.$saison.'.refresh', 0);
	}

?>