<?php

global $arbo, $affiche;
$arbo = 0;
$affiche = '';

function format($nb)
  {
  $result = "";
  for($ct=0; $ct<$nb; $ct++) $result .= '&nbsp;&nbsp;&nbsp;&nbsp;';
  return $result;
  }

function startElement($parser, $name, $attrs)
  {
  global $arbo, $affiche;
  if($name!="ERR" and $name!="LOG")
    {
    $affiche .= "<br>".format($arbo)."<b>$name</b>";
    if(!empty($attrs)) $affiche .= "&nbsp;(".implode(',', $attrs).")";
    $affiche .= "&nbsp;";
    $arbo++;
    }
  }

function endElement($parser, $name)
  {
  global $arbo, $affiche;
  if($name=="LOG") $affiche .= "<br>";
  else $arbo--;
  //$affiche .= format($arbo)."<b>Fin&nbsp;$name</b><br>";
  }

function dataHandler($parser, $data)
  {
  global $affiche, $arbo;
  $affiche .= TxtHTML(utf8_decode($data));
  }

global $module_ecran, $Session, $datamodule, $GS, $HTTP_GET_VARS, $site;

Librairie("sites");

$tpl = ModeleAdmin('page.html', 'logs');
$tpl->assign('LNK_REFRESH', "?$GS");

if(isset($HTTP_GET_VARS['log'])) $log = $HTTP_GET_VARS['log']; else $log = '';
if(isset($HTTP_GET_VARS['typ'])) $typ = $HTTP_GET_VARS['typ']; else $typ = '';
if(isset($HTTP_GET_VARS['suppr']))
  {
  if($typ=='adm') $chemin = CHEMIN_JOURNAUX.$HTTP_GET_VARS['suppr'];
  elseif($typ=='sit') $chemin = CHEMIN_JOURNAUX.$HTTP_GET_VARS['suppr'];
  msg_ajout("suppression de $chemin");
  unlink($chemin);
  $log='';
  $typ='';
  }

$sites = array();
$dir = dir(CHEMIN_JOURNAUX);
while($fichier = $dir->read()) if(!is_dir(CHEMIN_JOURNAUX.$fichier))
  {
  if($fichier!=urlencode($fichier)) trigger_error("Fichier au nom invalide <fichier>".TxtXml($fichier)."</fichier>", E_USER_WARNING);
  $tpl->assign('LNK', "?typ=adm&log=".urlencode($fichier)."&$GS");
  $tpl->assign('NOM', $fichier);
  $tpl->parse('MAIN.ADM');
  }
elseif($fichier!='.' and $fichier!='..') $sites[] = $fichier;

reset($sites);
while(list(, $valeur)=each($sites))
  {
  $tpl->assign('SITE', $valeur);

  $dir = dir(CHEMIN_JOURNAUX.$valeur);
  while($fichier = $dir->read()) if($fichier!='.' and $fichier!='..')
    {
    if($fichier!=urlencode($fichier)) trigger_error("Fichier au nom invalide <fichier>".TxtXml($fichier)."</fichier>", E_USER_WARNING);
    $tpl->assign('LNK', "?typ=sit&log=".urlencode("$valeur/$fichier")."&$GS");
    $tpl->assign('NOM', $fichier);
    $tpl->parse('MAIN.SITE.FICHIER');
    }

  $tpl->parse('MAIN.SITE');
  }

if($typ!='')
  {
  if($typ=='adm') $chemin = CHEMIN_JOURNAUX.$log;
  elseif($typ=='sit') $chemin = CHEMIN_JOURNAUX.'/'.$log;

  $tpl->assign('LNK', "?typ=$typ&suppr=".urlencode($log)."&$GS");
  $tpl->parse('MAIN.SUPPR');

  $xml_parser = xml_parser_create();
  xml_set_element_handler($xml_parser, "startElement", "endElement");
  xml_set_character_data_handler($xml_parser, "dataHandler");
  if (!($fp = fopen($chemin, "r"))) die("could not open XML input");

  xml_parse($xml_parser, '<?xml version="1.0" encoding="ISO-8859-1"?><err>', false);
  while ($data = fread($fp, 4096)) if (!xml_parse($xml_parser, $data, false))
    trigger_error("XML error: ".TxtXml(xml_error_string(xml_get_error_code($xml_parser)))." at line ".xml_get_current_line_number($xml_parser), E_USER_WARNING);
  xml_parse($xml_parser, "</err>", true);
  xml_parser_free($xml_parser);

  $tpl->assign('TITRE', $log);
  $tpl->assign('LOGS', $affiche);
  }

$tpl->parse('MAIN');
$module_ecran = $tpl->text('MAIN');

?>