<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = raction aux commandes sur l'arborescence des rubriques'
* *************************************************************************************
* Creation en dcembre 2001
**************************************************************************************/

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
  'cmd_ajouter',
  'cmd_supprimer',
  'cmd_editer',
  'cmd_supprconf',
  'cmd_monter',
  'cmd_descendre',
  'cmd_montrer',
  'cmd_cacher',
  'cmd_changerpere1',
  'cmd_changerpere2',
  'cmd_annuler');

/**************************************************************************************
  fonction de simplification du code
**************************************************************************************/

function ChangePere($data, $champ)
{
  global $datamodule;
  $datamodule['rubs'] = $data;
  reset($data);
	menu_refresh();
  while(list($key,) = each($data)) if(!EstAncetre($key, $champ))
    {
    msg_ajout(MSG_RUBRIQUEDEPLACEE);
    rub_changepere($key, $champ);
    }
  else msg_ajout(MSG_DESTISDESCENDANT);
}

/**************************************************************************************
  commandes
**************************************************************************************/
global $Session, $datamodule, $HTTP_POST_VARS;
Librairie('rubriques');

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, 'rub', 'rubs');
if(isset($HTTP_POST_VARS['clean_rubs'])) unset($datamodule['rubs']);
if(isset($datamodule['rub'])) unset($datamodule['rub']);

switch($cmd)
  {
  case 'cmd_rien' : break;

  case 'cmd_ajouter' :
    $Session['mode'] = 'edtrubs';
    $datamodule['rub'] = '';
    unset($datamodule['rubs']);
    break;

  case 'cmd_editer' :
    $Session['mode'] = 'edtrubs';
    $datamodule['rub'] = $data;
    unset($datamodule['rubs']);
    break;

   case 'cmd_supprconf' :
    if(!empty($data))
      {
      $datamodule['rubs'] = $data;
      $datamodule['confirmation'] = 1;
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['rubs']))
      {
      reset($datamodule['rubs']);
			$peres = array();
      while(list($val,)=each($datamodule['rubs']))
        {
        msg_ajout('suppression de "'.rub_titre($val).'"'); //TODO TRADUCTION
				$peres[rub_getpere($val)] = 1;
        rub_supprimer($val);
        }
			reset($peres);
			while(list($key,)=each($peres)) rub_defragplaces($key, $Session['site']);
      unset($datamodule['rubs']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;

  case 'cmd_monter' :
    if(!empty($data))
      {
      $datamodule['rubs'] = $data;
      rub_bouger($data, -1);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_descendre' :
    if(!empty($data))
      {
      $datamodule['rubs'] = $data;
      rub_bouger($data, +1);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_montrer' :
    if(!empty($data))
      {
      $datamodule['rubs'] = $data;
      rub_visible($data, 1);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_cacher' :
    if(!empty($data))
      {
      $datamodule['rubs'] = $data;
      rub_visible($data, 0);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_changerpere1' : ChangePere($data, $HTTP_POST_VARS['newpere1']); break;
  case 'cmd_changerpere2' : ChangePere($data, $HTTP_POST_VARS['newpere2']); break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

?>