<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric  
* Objet = affichage de l'arborecence des rubriques
* *************************************************************************************
* Creation en dcembre 2001
**************************************************************************************/

Librairie('rubriques');
global $module_ecran, $Session, $datamodule, $HGS, $HTTP_POST_VARS;

function AfficheListe($pere = 0)
  {
  global $Session, $GS, $datamodule;

  //liste des rubriques enfants de $pere
  $req = NewQuery('
    SELECT r.rub_id, rl.rul_titre, rl.rul_description, r.rub_visible, COUNT(rd.doc_id) AS NbLiens
    FROM ratrubriques AS r
      INNER JOIN ratlangues AS l ON l.lang_abrege="'.$Session['langue_edition'].'"
      INNER JOIN ratlnk_rublang AS rl ON rl.lang_id=l.lang_id AND r.rub_id=rl.rub_id
      LEFT JOIN ratlnk_rubdoc AS rd ON rd.rub_id=r.rub_id
    WHERE r.rubpere_id = '.$pere.' AND r.sit_id='.$Session['site'].'
    GROUP BY r.rub_id
    ORDER BY r.rub_place');
  if($req->next_record())
    {
    $tpl = ModeleAdmin('listerubs.html', 'menu');
    $tpl->assign('ITEMS', 'rubs');

    //pour la langue
    $tpl->assign('MSG_MONTER', MSG_MONTER);
    $tpl->assign('MSG_DESCENDRE', MSG_DESCENDRE);

    //liste des rubriques
    do
      {
      $tpl->assign('LNK_MONTER', '?cmd_monter=1&rub='.$req->f('rub_id').'&'.$GS);
      $tpl->assign('LNK_DESCENDRE', '?cmd_descendre=1&rub='.$req->f('rub_id').'&'.$GS);

      if(isset($datamodule['rubs'][$req->f('rub_id')])) $tpl->assign('ETATRUB', ' checked');
      else $tpl->assign('ETATRUB', '');

      $tpl->assign('COULEUR', $req->f('rub_visible') ? '#CCCCCC' : '#CCFFFF');
      $tpl->assign('ID', ''.$req->f('rub_id'));
      $tpl->assign('TITRE', TxtHTML($req->f('rul_titre')));
      $tpl->assign('LIEN', '?cmd_editer=1&rub='.$req->f('rub_id').'&'.$GS);
      $tpl->assign('DESCRIPTION', TxtHTML($req->f('rul_description')));

      $nbliens = $req->f('NbLiens')=='' ? 0 : $req->f('NbLiens');
      $tpl->assign('NBLIENS', ''.$nbliens);
      $tpl->assign('MSG_LIENS', $nbliens<2 ? MSG_LIEN : MSG_LIENS);

	  	//affichage des enfants de la rubrique
      $fils = AfficheListe($req->f('rub_id'));
      if($fils!='')
        {
        $tpl->assign('FILS', $fils);
        $tpl->parse('MAIN.RUBRIQUE.FILS');
        }

      $tpl->parse('MAIN.RUBRIQUE');
      }
    while($req->next_record());

    $tpl->parse('MAIN');
    return $tpl->text('MAIN');
    }
  else return '';
  }

function GetItems()
//rcupration des items 
  {
  global $datamodule;
  $result = array();

  if(!empty($datamodule['rubs']))
    {
    reset($datamodule['rubs']);
    while(list($val,)=each($datamodule['rubs'])) $result[] = rub_titre($val);
    }
  else trigger_error("datamodule['rubs'] est vide", E_USER_WARNING);

  return $result;
  }

if(isset($datamodule['confirmation']))
  {
  $tab = GetItems();
  if(count($tab)>1)
    $module_ecran = EcranConfirmation(MSG_SUPPRRUBS, $tab, 'cmd_supprimer', 'cmd_annuler');
  else $module_ecran = EcranConfirmation(MSG_SUPPRRUB, $tab, 'cmd_supprimer', 'cmd_annuler');
  }
else
  {
  $tpl = ModeleAdmin('liste.html', 'menu');

  /**************************************************************************************
    remplissage textes selon la langue
  **************************************************************************************/
  $tpl->assign('MSG_SUPPRIMER', MSG_SUPPRIMER);
  $tpl->assign('MSG_MONTER', MSG_MONTER);
  $tpl->assign('MSG_DESCENDRE', MSG_DESCENDRE);
  $tpl->assign('MSG_MONTRER', MSG_MONTRER);
  $tpl->assign('MSG_CACHER', MSG_CACHER);
  $tpl->assign('MSG_AJOUTER', MSG_AJOUTER);
  $tpl->assign('MSG_CHANGEPERE', MSG_CHANGEPERE);
  $tpl->assign('MSG_VALIDER', MSG_VALIDER);
  $tpl->assign('MSG_CHANGERPERE', MSG_CHANGEPERE);

  $tpl->assign('HIDDEN', '<input type="hidden" name="clean_rubs" value="1">'.$HGS);
  $tpl->assign('NEWPERE', '<option value="0">'.MSG_RACINE.'</option>'.
    ComboListRubriques('', 0, '&nbsp;&nbsp;&nbsp;&nbsp;'));

  //affichage de la liste
  $tpl->assign('LISTERUB', AfficheListe());

  /**************************************************************************************
    fin
  **************************************************************************************/
  $tpl->parse('MAIN');
  $module_ecran = $tpl->text('MAIN');
  }

?>