<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric  
* Objet = affichage de la liste des liens d'une rubrique
* *************************************************************************************
* Creation en dcembre 2001
**************************************************************************************/

Librairie('selectdoc');
global $module_ecran, $Session, $datamodule, $HGS, $HTTP_POST_VARS;

/**************************************************************************************
  fonctions d'allgement du code
**************************************************************************************/

function GetItems()
//recupration des items selectionns
  {
  global $datamodule;
  $result = array();

  if(!empty($datamodule['rubdoc']))
    {
    reset($datamodule['rubdoc']);
    while(list($val,)=each($datamodule['rubdoc']))
      $result[] = rubdoc_titre($val, $datamodule['rub']);
    }
  else trigger_error("datamodule['rubdoc'] non dfini <rubdoc>".$datamodule['rubdoc']."</rubdoc>", E_USER_WARNING);

  return $result;
  }
  
/**************************************************************************************
  affichage des crans
**************************************************************************************/

if(isset($datamodule['confirmation']))
  {
  $tab = GetItems();
  if(count($tab)>1)
    $module_ecran = EcranConfirmation('Voulez vous supprimer les liens avec ces documents?', $tab, 'cmd_supprimer', 'cmd_annuler');
  else $module_ecran = EcranConfirmation('Voulez vous supprimer le lien avec ce document?', $tab, 'cmd_supprimer', 'cmd_annuler');
  }
else
  {
  $tpl = ModeleAdmin('edit_liens.html', 'menu');

  /**************************************************************************************
    remplissage textes selon la langue
  **************************************************************************************/
  $tpl->assign('MSG_RETOURALALISTE', MSG_RETOURALALISTE);
  $tpl->assign('MSG_VALIDER', MSG_VALIDER);
  $tpl->assign('MSG_EDITER', MSG_EDITER);
  $tpl->assign('MSG_AJOUTER', MSG_AJOUTER);
  $tpl->assign('MSG_MONTER', MSG_MONTER);
  $tpl->assign('MSG_DESCENDRE', MSG_DESCENDRE);
  $tpl->ASSIGN('MSG_SUPPRIMER', MSG_SUPPRIMER);

  $tpl->assign('ITEMS', 'rubdoc');
  $tpl->assign('JAVASCRIPT', GetJS($dos_libre, $doc_libre, $dos_all, $doc_all));

  /**************************************************************************************
    affichage de la page
  **************************************************************************************/

  $req = NewQuery('
    SELECT
      doc.dos_id, dos.dos_nom,
      doc.doc_id, doc.doc_designation, dol.dol_titre,
      pers.pers_nom, pers.pers_prenom,
			rub.maindoc_id
    FROM ratdocuments AS doc
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$Session['langue_edition'].'"
      INNER JOIN ratlnk_rubdoc AS rud ON rud.doc_id=doc.doc_id AND rud.rub_id='.$datamodule['rub'].'
			INNER JOIN ratrubriques AS rub ON rud.rub_id=rub.rub_id
      INNER JOIN ratdossiers AS dos ON doc.dos_id=dos.dos_id
      INNER JOIN ratpersonnes AS pers ON pers.pers_id=doc.pers_id
      INNER JOIN ratlnk_doclang AS dol ON doc.doc_id=dol.doc_id AND dol.lang_id=lang.lang_id
    ORDER BY dos.dos_nom');
  if($req->next_record())
    {
    $dossier_id = $req->f('dos_id');
    do
      {
      if($dossier_id != $req->f('dos_id'))
        {
        $tpl->parse('MAIN.DOSSIER');
        $dossier_id = $req->f('dos_id');
        }
			
			if($req->f('maindoc_id')==0) $tpl->assign('NONE_MAINDOC', ' checked');
      $tpl->assign('NOMDOSSIER', TxtHTML($req->f('dos_nom')));
			$tpl->assign('MAINDOC', $req->f('maindoc_id')==$req->f('doc_id') ? ' checked' : '');
      $tpl->assign('NOMDOC', TxtHTML($req->f('doc_designation')));
      $tpl->assign('DOCTRADUIT', TxtHTML($req->f('dol_titre')));
      $tpl->assign('NOM', TxtHTML($req->f('pers_nom')));
      $tpl->assign('PRENOM', TxtHTML($req->f('pers_prenom')));
      $tpl->assign('ID', $req->f('doc_id'));
      $tpl->assign('SID', $req->f('dol_titre'));
      $tpl->assign('STATE', isset($datamodule['rubdoc'][$req->f('doc_id')])?' checked':'');

      $tpl->parse('MAIN.DOSSIER.LIEN');
      }
    while($req->next_record());
    $tpl->parse('MAIN.DOSSIER');
    }
  else 
		{
		$tpl->assign('NONE_MAINDOC', ' checked');
		$tpl->parse('MAIN.NOLIEN');
		}

  $tpl->assign('DOS_LIBRE', $dos_libre);
  $tpl->assign('DOC_LIBRE', $doc_libre);
  $tpl->assign('DOS_ALL', $dos_all);
  $tpl->assign('DOC_ALL', $doc_all);
  $tpl->assign('LISTERUBSCHG', ComboListRubriques($datamodule['rub']));

  /**************************************************************************************
    divers
  **************************************************************************************/
  $tpl->assign('HIDDEN', $HGS.'<input type="hidden" name="'.IDENT_EDIT_RUBLIENS.'" value="1">');
  $tpl->assign('METHODE', 'post');
  $tpl->assign('ACTION', '?');

  /**************************************************************************************
    fin
  **************************************************************************************/
  $tpl->parse('MAIN');
  $module_ecran = $tpl->text('MAIN');
  }

?>