<?php

Librairie('utilitaires');
Librairie('rawdata');
	
function SendNewsletter()
	{
	global $Session, $HTTP_POST_VARS;

	$zoomtypes = array();
	$req = NewQuery('
		select ztl.lang_id, ztl.ztyp_id, ztl.ztl_titre
    from ratzoomtype as ztyp
      inner join ratlnk_ztyplang as ztl on ztl.ztyp_id=ztyp.ztyp_id
    where ztyp.sit_id='.$Session['site'].' and ztyp.ztyp_lettre=1
    order by ztl.lang_id, ztl.ztl_titre');
	while($req->next_record())
		$zoomtypes[$req->f('lang_id')][$req->f('ztyp_id')] = $req->f('ztl_titre');
	
	$req = NewQuery('
    SELECT
      zoom.zoom_id, zoom.zoom_url, zoom.doc_id, zoom.zoom_modif,
      ztl.ztyp_id, ztl.ztl_titre,
      zol.zool_titre, zol.zool_description, 
			lang.lang_id, lang.lang_abrege
    FROM ratzooms AS zoom
      INNER JOIN ratlnk_zoomtype AS zt ON zt.zoom_id=zoom.zoom_id
      INNER JOIN ratzoomtype AS ztyp ON ztyp.ztyp_id=zt.ztyp_id AND ztyp.sit_id=zoom.sit_id AND ztyp.ztyp_lettre=1
      INNER JOIN ratlnk_ztyplang AS ztl ON ztl.ztyp_id=zt.ztyp_id
      INNER JOIN ratlnk_zoolang AS zol ON zol.lang_id=ztl.lang_id AND zol.zoom_id=zoom.zoom_id AND zol.zool_visible=1
			INNER JOIN ratlangues AS lang ON lang.lang_id=ztl.lang_id
    WHERE zoom.zoom_lettre=1 AND zoom.zoom_visible=1 AND zoom.sit_id='.$Session['site'].'
		ORDER BY zoom.zoom_valeur DESC');
		
	$zooms = array();
	$id = 0;
	$lang = 0;
	while($req->next_record())
		{
		$zooms_id[$req->f('zoom_id')] = $req->f('zoom_id');
		if($id!=$req->f('zoom_id'))
			{
			if($id!=0) 
				{
				$zooms[$id][$lang]['ztyps'] = implode(', ', $ztyps);
				$zooms[$id][$lang]['ztyps_id'] = array_keys($ztyps);
				}
			$id = $req->f('zoom_id');			
			$lang = $req->f('lang_id');
			$ztyps = array();
			}

		if($req->f('doc_id')!='') 
			$zooms[$id][$lang]['url'] = BASEREF.'?doc='.$req->f('doc_id').'&lang='.$req->f('lang_abrege');
		else $zooms[$id][$lang]['url'] = $req->f('zoom_url');
		$zooms[$id][$lang]['date'] = date_m2p($req->f('zoom_modif'));
		$zooms[$id][$lang]['titre'] = $req->f('zool_titre');
		$zooms[$id][$lang]['texte'] = $req->f('zool_description');
		$ztyps[$req->f('ztyp_id')] = $req->f('ztl_titre');
		}
	
	if(isset($ztyps))
		{
		$zooms[$id][$lang]['ztyps'] = implode(', ', $ztyps);
		$zooms[$id][$lang]['ztyps_id'] = array_keys($ztyps);
		}
		
	$req = NewQuery('
    select
      ins.ins_id, ins.ins_nom, ins.ins_courriel, ins.ins_code, ins.lang_id,
      ztl.ztyp_id, ztl.ztl_titre, lang.lang_abrege
    from ratinscrits as ins
			inner join ratlangues as lang on lang.lang_id=ins.lang_id
      inner join ratlnk_inscritztyp as izt on izt.ins_id=ins.ins_id
      inner join ratlnk_ztyplang as ztl on ztl.lang_id=ins.lang_id and ztl.ztyp_id=izt.ztyp_id
    where ins.ins_etat=2 and ins.sit_id='.$Session['site'].'
    order by ins.ins_id');

	$inscrits = array();
	$id = 0;
	while($req->next_record()) 
		{
		$id = $req->f('ins_id');
		$inscrits[$id]['nom'] = $req->f('ins_nom');
		$inscrits[$id]['code'] = $req->f('ins_code');
		$inscrits[$id]['langue'] = $req->f('lang_id');
		$inscrits[$id]['langue_abrege'] = $req->f('lang_abrege');
		$inscrits[$id]['domaines'][$req->f('ztyp_id')] = $req->f('ztl_titre');
		$inscrits[$id]['courriel'] = $req->f('ins_courriel');
		}
		
	reset($inscrits);
	$doc_id = getData('zooms', 'docml', 0);
	if($doc_id==0) msg_ajout('document de gestion de la liste non dfini');
	while(list(, $inscrit)=each($inscrits))
		{
		$ztyps_id = array_keys($inscrit['domaines']);
		$tpl = ModeleSite('courriel.txt', 'zooms');
		$tpl->assign('DOC_ID', $doc_id.''); 
		$tpl->assign('LANG_ABREGE', $inscrit['langue_abrege']);
  	$tpl->assign('NOM', $inscrit['nom']);
  	$tpl->assign('CODE', $inscrit['code']);
		if(isset($HTTP_POST_VARS['edito'])) $tpl->assign('EDITO', $HTTP_POST_VARS['edito']);
  	reset($zooms);
  	while(list(,$news)=each($zooms)) if(isset($news[$inscrit['langue']])) 
			{
			$n = $news[$inscrit['langue']];
			if(count(array_intersect($ztyps_id, $n['ztyps_id']))>0)
    		{
    		$tpl->assign('TITRE', stripslashes($n['titre']));
				$tpl->assign('DATE', $n['date']);
    		$tpl->assign('DOMAINES', $n['ztyps']);
    		$tpl->assign('ADRESSE', $n['url']);
    		$tpl->assign('TEXTE', stripslashes($n['texte']));
    		$tpl->parse('MAIN.NEWS');
    		}	
			}
		$autres = array_diff($zoomtypes[$inscrit['langue']], $inscrit['domaines']);
		if(count($autres)>0)
			{
			$tpl->assign('DOMAINES', implode(', ', $autres));
			$tpl->parse('MAIN.DOMAINES');
			}
		else $tpl->parse('MAIN.NO_DOMAINES');
		$tpl->assign('DOMAINES', implode(', ', $inscrit['domaines']));
		$tpl->parse('MAIN');
		if(courriel($inscrit['courriel'], getproprio(), ML_TITRE, $tpl->text('MAIN')))
			msg_ajout('envoi de la lettre  '.$inscrit['nom']);
		else msg_ajout("Erreur dans l'envoi du courriel  ".$inscrit['nom']);
		}
	if(isset($zooms_id)) NewQuery('UPDATE ratzooms SET zoom_lettre=0 WHERE zoom_id IN ('.implode(',', $zooms_id).')');
	}

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
	'cmd_ztyps',
	'cmd_zooms',
 	'cmd_inscrits',
  'cmd_send');
	
/**************************************************************************************
  commandes
**************************************************************************************/

global $Session, $datamodule, $HTTP_POST_VARS, $HTTP_GET_VARS;
GetCommandeAndItems($cmd, $liste_commandes, $datamodule, '', '');

switch($cmd)
  {
  case 'cmd_rien' : break;

	case 'cmd_ztyps' :
    $Session['mode'] = 'zoomtypes';
    break;

	case 'cmd_zooms' : 
		$Session['mode'] = 'principal';
		break;
		
	case 'cmd_lettres' : 
		$Session['mode'] = 'lettres';
		break;
	
	case 'cmd_inscrits' : 
		$Session['mode'] = 'inscrits';
		break;

	case 'cmd_send' : 
		if(!isset($HTTP_POST_VARS['listevide']) or !empty($HTTP_POST_VARS['edito'])) SendNewsletter();	
		else msg_ajout('Aucun zoom  envoyer');	
		break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }


?>