<?

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
	'cmd_send',
	'cmd_ztyps',
	'cmd_zooms',
  'cmd_ajouter',
	'cmd_supprconf', 
	'cmd_inscription', 
	'cmd_inscrit',
	'cmd_suppression',
	'cmd_sommeil',
	'cmd_lettres', 
	'cmd_zooms', 
	'cmd_filtre',
	'cmd_supprimer', 
	'cmd_annuler', 
	'cmd_editer');
	
/**************************************************************************************
  commandes
**************************************************************************************/

global $Session, $datamodule, $HTTP_POST_VARS, $HTTP_GET_VARS;
Librairie('inscrits');

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, '', 'inscrits');
if(isset($datamodule['inscrit'])) unset($datamodule['inscrit']);
if(!empty($data)) $datamodule['inscrits'] = $data;

switch($cmd)
  {
  case 'cmd_rien' : break;
		
	case 'cmd_send' : 
    $Session['mode'] = 'envoi';
    break;

	case 'cmd_ztyps' :
    $Session['mode'] = 'zoomtypes';
    break;

  case 'cmd_zooms' :
    $Session['mode'] = 'principal';
    break;

  case 'cmd_supprconf' :
    if(!empty($data))
      {
      $datamodule['inscrits'] = $data;
      $datamodule['confirmation'] = 1;
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['inscrits']))
      {
      reset($datamodule['inscrits']);
      while(list($val,)=each($datamodule['inscrits']))
        {
        msg_ajout('suppression de "'.inscrit_designation($val).'"'); //TODO TRADUCTION
        inscrit_supprimer($val);
        }
      unset($datamodule['inscrits']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;
				 
	case 'cmd_inscription' :
	  if(empty($data)) msg_ajout(MSG_NONESELECTED);
    else Inscrit_ChangeEtat($data, IS_ENTREE); 
		break;
		  
	case 'cmd_inscrit' : 
	  if(empty($data)) msg_ajout(MSG_NONESELECTED);
    else Inscrit_ChangeEtat($data, IS_INSCRIT); 
		break;
		 
	case 'cmd_suppression' : 
	  if(empty($data)) msg_ajout(MSG_NONESELECTED);
    else Inscrit_ChangeEtat($data, IS_SUPPRESSION); 
		break;
		 
	case 'cmd_sommeil' : 
	  if(empty($data)) msg_ajout(MSG_NONESELECTED);
    else Inscrit_ChangeEtat($data, IS_SOMMEIL); 
		break;
		 
 	case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;
		
	case 'cmd_ajouter' : 
  	$Session['mode'] = 'inscrit_edit';
  	$datamodule['inscrit'] = 0;
		break;
		
	case 'cmd_editer' : 
		$Session['mode'] = 'inscrit_edit';
		$datamodule['inscrit'] = $HTTP_GET_VARS['cmd_editer'];
		break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

/**************************************************************************************
  gestion du filtre
**************************************************************************************/

function FromPost($valeur)
  {
  global $HTTP_POST_VARS, $datamodule;
  if(isset($HTTP_POST_VARS[$valeur])) $datamodule[$valeur] = $HTTP_POST_VARS[$valeur];
  }

function FromGet($valeur)
  {
  global $HTTP_GET_VARS, $datamodule;
  if(isset($HTTP_GET_VARS[$valeur])) $datamodule[$valeur] = $HTTP_GET_VARS[$valeur];
  }

if(isset($HTTP_POST_VARS['nofiltre']))
  {
  unset($datamodule['filtre_nom']);
  unset($datamodule['filtre_entrees']);
  unset($datamodule['filtre_inscrits']);
  unset($datamodule['filtre_sorties']);
	unset($datamodule['filtre_sommeil']);
  }
else
  {
  FromPost('filtre_nom');
  unset($datamodule['filtre_entrees']);
	FromPost('filtre_entrees');
  unset($datamodule['filtre_inscrits']);
	FromPost('filtre_inscrits');
  unset($datamodule['filtre_sorties']);
	FromPost('filtre_sorties');
	unset($datamodule['filtre_sommeil']);
	FromPost('filtre_sommeil');
  }
FromGet('sort');
FromGet('sens');

?>