<?

Librairie('selectdoc');

global $module_ecran, $Session, $datamodule, $GS, $HGS, $HTTP_POST_VARS;

function GetItems()
  {
  global $datamodule;
  $result = array();

  if(!empty($datamodule['zooms']))
    {
    reset($datamodule['zooms']);
    while(list($val,)=each($datamodule['zooms'])) $result[] = zoom_designation($val);
    }
  else trigger_error("datamodule['zooms'] est vide", E_USER_WARNING);

  return $result;
  }

/**************************************************************************************
  affichage
**************************************************************************************/
if(isset($datamodule['confirmation']))
  {
  $tab = GetItems();
  if(count($tab)>1)
    $module_ecran = EcranConfirmation('Voulez vous supprimer ces zooms?', $tab, 'cmd_supprimer', 'cmd_annuler');
  else $module_ecran = EcranConfirmation('Voulez vous supprimer ce zoom?', $tab, 'cmd_supprimer', 'cmd_annuler');
  }
else
  {
  if(!isset($datamodule['filtre_auteur'])) $datamodule['filtre_auteur'] = '';
	if(!isset($datamodule['filtre_type'])) $datamodule['filtre_type'] = '';
	if(!isset($datamodule['filtre_motsclefs'])) $datamodule['filtre_motsclefs'] = '';
	if(!isset($datamodule['filtre_ml'])) $datamodule['filtre_ml'] = '';

  $tpl = ModeleAdmin('principale.html', 'zooms');
  $tpl->assign('HIDDEN', $HGS);
  $tpl->assign('SID', $GS);
  $tpl->assign('JAVASCRIPT', GetJSListe());
  GetJSSelect($dos, 0, $doc, 0);
  $tpl->assign('DOS_ADDZOOM', $dos);
  $tpl->assign('DOC_ADDZOOM', $doc);

  /**************************************************************************************
    affichage boite de filtre
  **************************************************************************************/
  $tpl->assign('LISTE_AUTEURS', '<option value=""></option>'.Sql2Options('
    SELECT pers.pers_id AS chp1, pers.pers_prenom AS chp2, pers.pers_nom AS chp3
    FROM ratpersonnes AS pers
      INNER JOIN ratlnk_grppers AS gpe ON gpe.pers_id=pers.pers_id
      INNER JOIN ratlnk_sitegroupe as sig ON sig.grp_id=gpe.grp_id AND sig.sit_id='.$Session['site'].'
    ORDER BY pers_prenom, pers_nom', VorN(@$datamodule['filtre_auteur'])));

  $tpl->assign('LISTE_TYPE', '<option value=""></option>'.Sql2Options('
    SELECT ztyp_id as chp1, ztyp_ident as chp2 FROM ratzoomtype WHERE sit_id='.$Session['site'].' ORDER BY ztyp_ident', VorN(@$datamodule['filtre_type'])));

  $tpl->assign('NEW_TYPE', Sql2Options('
    SELECT ztyp_id as chp1, ztyp_ident as chp2 FROM ratzoomtype WHERE sit_id='.$Session['site'].' ORDER BY ztyp_ident'));
  $tpl->assign('FILTRE', @$datamodule['filtre_motsclefs']);
	$tpl->assign('ST_ML', @$datamodule['filtre_ml']==1 ? ' checked' : '');

  /**************************************************************************************
    affichage liste des documents
  **************************************************************************************/

  $corresColonnes = array(
    'titre' => 'doc.doc_designation',
    'auteur' => 'doc.per_id',
    'module' => 'mol.mol_texte',
    'maj' => 'doc.doc_modification');
  $corresSens = array('up' => 'ASC', 'dn' => 'DESC');

  if(!empty($datamodule['sort']))
  $clause_trier=' ORDER BY '.$corresColonnes[$datamodule['sort']].' '.$corresSens[$datamodule['sens']];
  else $clause_trier='';
	
  $clause_filtrer="";
  if(!empty($datamodule['filtre_ml'])) 
		$clause_filtrer .= ' AND zoo.zoom_lettre=1';
  if(!empty($datamodule['filtre_auteur']))
    $clause_filtrer.=' AND pers.pers_id='.$datamodule['filtre_auteur'];
  if(!empty($datamodule['filtre_type']))
    $clause_filtrer.=' AND ztyp.ztyp_id='.Vor0(@$datamodule['filtre_type']);
  if(!empty($datamodule['filtre_motsclefs']))
    {
    $tab = explode(' ', $datamodule['filtre_motsclefs']);
    for($i=0, $max=count($tab); $i<$max; $i++)
      $clause_filtrer.=' and (zoo.zoom_ident LIKE "%'.$tab[$i].'%" OR zol.zool_titre LIKE "%'.$tab[$i].'%")';
    }
		
  $sql = '
    SELECT
      zoo.zoom_id, zoo.zoom_ident, zol.zool_titre, zol.lang_id as zool_id, zoo.zoom_valeur, zoo.zoom_visible,
      ztyp.ztyp_ident, pers.pers_prenom, pers.pers_nom
    FROM ratzooms AS zoo
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$Session['langue_edition'].'"
      LEFT OUTER JOIN ratlnk_zoomtype AS lnkztyp ON zoo.zoom_id=lnkztyp.zoom_id
      LEFT OUTER JOIN ratzoomtype AS ztyp ON ztyp.ztyp_id=lnkztyp.ztyp_id AND ztyp.sit_id='.$Session['site'].'
      INNER JOIN ratpersonnes AS pers ON pers.pers_id=zoo.pers_id
      LEFT OUTER JOIN ratlnk_zoolang AS zol ON zol.zoom_id=zoo.zoom_id AND zol.lang_id=lang.lang_id
    WHERE zoo.sit_id='.$Session['site'].' '.$clause_filtrer/*.$clause_trier*/.' ORDER BY zoo.zoom_valeur DESC, zoo.zoom_id, ztyp.ztyp_ident ASC';

  $req = NewQuery($sql);

  if($req->next_record())
    {
    $zoom_id = $req->f('zoom_id');
    $cats = array();
    do
      {
			$tpl->assign('ZOOM_COULEUR', $req->f('zoom_visible')==1 ? '#CCCCCC' : '#CCFFFF');
      $tpl->assign('STATE', isset($datamodule['zooms'][$req->f('zoom_id')]) ? ' checked' : '');
      $tpl->assign('ZOOM_ID', $req->f('zoom_id'));
      if($req->f('zool_id')=='') $titre = '--non traduit--'; else $titre = '"'.TxtHTML($req->f('zool_titre')).'"';
      $tpl->assign('ZOOM_IDENT', TxtHTML($req->f('zoom_ident')).'&nbsp;('.$titre.')');
      $cats[] = $req->f('ztyp_ident');
      $tpl->assign('ZOOM_CATS', implode(', ', $cats));
      $tpl->assign('ZOOM_VALEUR', $req->f('zoom_valeur').'');
      $tpl->assign('ZOOM_AUTEUR', ChaineFrm(TxtHTML($req->f('pers_prenom')).'&nbsp;'.TxtHTML($req->f('pers_nom'))));
      $tpl->assign('LNK_EDIT', '?cmd_editer='.$req->f('zoom_id').'&'.$GS);
      $tpl->assign('LNK_VOIR', '');
      //$tpl->parse('MAIN.LIGNE');
      $go = $req->next_record();
      if($zoom_id != $req->f('zoom_id'))
        {
        $tpl->parse('MAIN.LIGNE');
        $cats=array();
        $zoom_id = $req->f('zoom_id');
        }
      }
      while($go);
    }
  else $tpl->parse('MAIN.LISTEVIDE');

  /**************************************************************************************
    fin
  **************************************************************************************/
  $tpl->parse('MAIN');
  $module_ecran = $tpl->text('MAIN');
  }

?>