<?php

global $msg_gene, $Session;

Librairie('rawdata');
Classe('documents');
Librairie('documents');
Librairie('utilitaires');
Librairie('dossiers');
Librairie('personnes');

if(!defined('ZOOMS_REGENERE')) {
define('ZOOMS_REGENERE', 1);

function zoom_generebloc($ztyp_id, $langue)
//gnration du bloc html
  {
  $req = NewQuery('
    SELECT zoom.zoom_id, doc_id, zoom_url, zoom_modif, zool_titre, zool_description
    FROM ratzooms AS zoom
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$langue.'"
      INNER JOIN ratlnk_zoolang AS zol ON zol.lang_id=lang.lang_id AND zoom.zoom_id=zol.zoom_id
      INNER JOIN ratlnk_zoomtype AS zot ON zoom.zoom_id=zot.zoom_id AND zot.ztyp_id='.$ztyp_id.'
    WHERE zoom.zoom_visible=1 AND zol.zool_visible=1 ORDER BY zoom.zoom_valeur ASC');

  if($req->next_record())
    {
    $tpl = ModeleSite('tpl_bloc.html', 'zooms');
    do
      {
      $tpl->assign('TITRE', str_replace(" ", "&nbsp;", TxtHTML($req->f('zool_titre'))));
      $tpl->assign('DATE', date_m2p($req->f('zoom_modif')));
      $tpl->assign('TEXTE', TxtHTML($req->f('zool_description')));
      if($req->f('doc_id')=='')
        {
        $tpl->assign('LIEN', $req->f('zoom_url'));
        $tpl->assign('TARGET', '_blank');
        }
      else
        {
        $tpl->assign('LIEN', '?doc='.$req->f('doc_id').'&lang='.$langue);
        $tpl->assign('TARGET', '_top');
        }
      $tpl->parse('MAIN.ZOOM.NORMAL');
      $tpl->parse('MAIN.ZOOM');
      }
      while($req->next_record());
    $tpl->parse('MAIN');
    return $tpl->text('MAIN');
    }
  else trigger_error("zooms non trouve <zoom>$ztyp_id</zoom><langue>$langue</langue>", E_USER_WARNING);
  }
	
function zoom_generepage($ztyp_id, $langue)
  {
  $req = NewQuery('
    SELECT zoom.zoom_id, doc_id, zoom_url, zoom_modif, zool_titre, zool_description
    FROM ratzooms AS zoom
      INNER JOIN ratlangues AS lang ON lang.lang_abrege="'.$langue.'"
      INNER JOIN ratlnk_zoolang AS zol ON zol.lang_id=lang.lang_id AND zoom.zoom_id=zol.zoom_id
      INNER JOIN ratlnk_zoomtype AS zot ON zoom.zoom_id=zot.zoom_id AND zot.ztyp_id='.$ztyp_id.'
    WHERE zoom.zoom_visible=1 AND zol.zool_visible=1 ORDER BY zoom.zoom_valeur ASC');

  if($req->next_record())
    {
    $tpl = ModeleSite('tpl_document.html', 'zooms');
    do
      {
      $tpl->assign('TITRE', TxtHTML($req->f('zool_titre')));
      $tpl->assign('DATE', date_m2p($req->f('zoom_modif')));
      $tpl->assign('TEXTE', TxtHTML($req->f('zool_description')));
      if($req->f('doc_id')=='')
        {
        $tpl->assign('LIEN', $req->f('zoom_url'));
        $tpl->assign('TARGET', '_blank');
        }
      else
        {
        $tpl->assign('LIEN', '?doc='.$req->f('doc_id').'&lang='.$langue);
        $tpl->assign('TARGET', '_top');
        }
      $tpl->parse('MAIN.ZOOM.NORMAL');
      $tpl->parse('MAIN.ZOOM');
      }
      while($req->next_record());
    $tpl->parse('MAIN');
    return $tpl->text('MAIN');
    }
  else trigger_error("zooms non trouve <zoom>$ztyp_id</zoom><langue>$langue</langue>", E_USER_WARNING);
  }

function newsletter_generepage()
	{
	$tpl = ModeleSite('newsletter.html', 'zooms');
	$tpl->parse('MAIN');
	return $tpl->text('MAIN');
	}
	
} //fin !defined('ERREURSVITRINE_REGENERE')


$req = NewQuery('
  SELECT ztyp_id, ztyp_ident, ztyp_doc_id
  FROM ratzoomtype
  WHERE sit_id='.$Session['site'].' AND ztyp_bloc_refresh=1');
$liste = explode(',', LANGUES_LISTE);
while($req->next_record())
  {
  reset($liste);
  while(list(, $val)=each($liste))
    {
		//bloc zoom
    blocSauve('zooms', strtolower($req->f('ztyp_ident')).'.'.$val, zoom_generebloc($req->f('ztyp_id'), $val));
		
		//gnration du document liste
		$document = $req->f('ztyp_doc_id');
    if(empty($document))
      { //gestion pour la cration ventuelle d'un document
  		$doc = new CClassDoc(0, 1);
  		$doc->Personne(Personne_systeme());
  		$doc->Module(module_id('zooms'));
  		$doc->Visible(true);
  		$doc->EnTete(true);
  		$doc->Navigation(false);
  		$doc->Sommaire(false);
  		$doc->Dossier(dos_systeme($Session['site']));
  		$doc->Designation('Document Zooms '.$req->f('ztyp_ident'));
      }
    else $doc = new CClassDoc($document, 1);
  
  	//sauve le document pour la langue
    $doc->Titre('Zooms '.$req->f('ztyp_ident')); //todo traduction
    $doc->MotsClefs('');
    $doc->Description('Liste des zooms de cette catgorie');
    $doc->VisLang(true);
    $doc->Sauver();
  	if(empty($document)) $document = $doc->id; 
		NewQuery('UPDATE ratzoomtype SET ztyp_doc_id='.$document.' WHERE ztyp_id='.$req->f('ztyp_id'));
  	
  	$pag = $doc->Page(1);
  	$pag->Ident('principale');
  	$pag->Visible(true);
  	$pag->TexteCommun(false);
  	$pag->VisLang(true);
  	$pag->Titre(''); //todo traduction
  	$pag->Description('');
  	$pag->Texte(zoom_generepage($req->f('ztyp_id'), $val));	
  	$pag->Sauver();    
		}
		
	//on poste la validation
	NewQuery('UPDATE ratzoomtype SET ztyp_bloc_refresh=0 WHERE ztyp_id='.$req->f('ztyp_id'));
	$msg_gene[] = 'ZOOMS: gnration du document de type de zooms '.$req->f('ztyp_ident');
  }
	
//gestion de la page d'inscription
//todo  finir
/*
if(getData('zooms', 'newsletter_refresh', 1))
	{
	$document = getData('zooms', 'newsletter_document', 0);
	
  if($document==0)
    { //gestion pour la cration ventuelle d'un document
		$doc = new CClassDoc(0, 1);
		$doc->Personne(Personne_systeme());
		$doc->Module(module_id('zooms'));
		$doc->Visible(true);
		$doc->EnTete(true);
		$doc->Navigation(false);
		$doc->Sommaire(false);
		$doc->Dossier(dos_systeme($Session['site']));
		$doc->Designation('Liste de diffusion');
    }
  else $doc = new CClassDoc($document, 1);

	//sauve le document pour la langue
  $doc->Titre('Liste de diffusion'); //todo traduction
  $doc->MotsClefs('');
  $doc->Description("Gestion de votre inscription  la liste");
  $doc->VisLang(true);
  $doc->Sauver();
	if($document==0) setData('zooms', 'newsletter_document', $doc->id);
	
	$pag = $doc->Page(1);
	$pag->Ident('principale');
	$pag->Visible(true);
	$pag->TexteCommun(false);
	$pag->VisLang(true);
	$pag->Titre('Gestion'); //todo traduction
	$pag->Description('');
	$pag->Texte(newsletter_generepage(1));	
	$pag->Sauver(); 
	
	$msg_gene[] = 'ZOOMS: Gnration de la fiche de newsletter';
	setData('zooms', 'newsletter_refresh', 0);
	}
*/


?>