<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = configuration de RAT sur le serveur
* *************************************************************************************
* Creation en dcembre 2001
**************************************************************************************/

set_magic_quotes_runtime(0);
error_reporting(E_ALL);
global $site;

/**************************************************************************************
  Gestion du serveur
**************************************************************************************/
	define('SYSTEM', 'WIN32');
	
  //define('LIEU', 'ORTH');
  define('LIEU', 'AC');
  //define('LIEU', 'MNEMENTH');

  if(LIEU=='ORTH') define('CHEMIN_ROOT', 'D:/Dev/webs/rat/rat03/');
  elseif(LIEU=='AC') define('CHEMIN_ROOT', 'E:/Travail/web/rat03/');
  elseif(LIEU=='MNEMENTH') define('CHEMIN_ROOT', 'D:/Dev/webs/rat03/');	

  define('DB_HOST', '127.0.0.1');
  define('DB_NAME', 'rat03');
  define('DB_LOGIN', 'root');
  define('DB_PASSWORD', '');

/**************************************************************************************
  Chemins
**************************************************************************************/
define('CHEMIN_CODE', CHEMIN_ROOT.'rat_code/');
define('CHEMIN_LIBS', CHEMIN_CODE.'libs/');
define('CHEMIN_MODULES', CHEMIN_CODE.'modules/');
define('CHEMIN_TEMPORAIRE', CHEMIN_ROOT.'rat_donnees/');
define('CHEMIN_JOURNAUX', CHEMIN_TEMPORAIRE.'journaux/');
define('CHEMIN_SESSIONS', CHEMIN_TEMPORAIRE.'sessions/');
define('CHEMIN_TMP', CHEMIN_TEMPORAIRE.'tmp/');

define('CHEMIN_ADMIN', CHEMIN_ROOT.'admin/');
define('CHEMIN_ADMINMODELES', CHEMIN_ADMIN.'modeles/');

define('CHEMIN_SITES', CHEMIN_ROOT.'rat_sites/');

/**************************************************************************************
  Divers informations
**************************************************************************************/
define('VERSION', '0.3c');
define('ROOT_MAIL', 'cedric@daneel.net');

define('EXT', '.php');
define('INDEX', 'index'.EXT);

$rat = array();

/**************************************************************************************
  configurations diverses
**************************************************************************************/
define('RATLANGUE_DEFAUT', 'fr');
define('RATLANGUES_LISTE', 'fr');
define('SESSIONLIFE', 20*60);    //timeout des sessions en secondes
define('IDFICHIER', 'gss'); //prfixe des fichiers de session

/**************************************************************************************
  les diffrentes sites
**************************************************************************************/
define('SITE_DEFAUT', 'PLC');
$sites = array(
  '172.16.1.140' => 'PLC',
  '127.0.0.1' => 'PLC',
  'localhost' => 'localhost');

/**************************************************************************************
  fonctions propres
**************************************************************************************/

if(LIEU=='NEXEN') 
	{
	include 'nexen.php';
	}
elseif(SYSTEM=='UNIX')
	{
    function rat_chmod($fichier, $attr) { return chmod($fichier, $attr); }
    function rat_chown($file, $user='') { return chown($file, $user); }  
		function rat_courriel($to, $from, $subject, $message, $additional_headers="", $additional_parameters="") { return mail($to, $subject, $message, $additional_headers, $additional_parameters); }
	}
else
	{
    function rat_chmod($fichier, $attr) { return true; }
    function rat_chown($file, $user='') { return true; }  
		function rat_courriel($to, $from, $subject, $message, $additional_headers="", $additional_parameters="") { return true; }
	}

function courriel($to, $from, $sujet, $message, $headers='')
	{
	//todo gestion from dans les headers
	$headers = "From:$from\r\n$headers";
  AddLog(Txt("<to>".TxtXml($to)."</to><from>".TxtXml($from)."</from><sujet>".TxtXml($sujet)."</sujet>"
		."<addheaders>".TxtXml($headers)."</addheaders>"."<msg>".TxtXml($message)."</msg>"), 'courriels.txt');
	return rat_courriel($to, $sujet, $message, $headers);
	}
	
function root_courriel($email, $titre, $message)
  {
	return courriel(ROOT_MAIL, $email, '[RAT]'.$titre, $message);
  }
	
function getproprio()
	{
	if(defined('ADMINISTRATION'))
		{
		global $Session;
		
		$req = NewQuery('SELECT pers.pers_id, pers.pers_courriel FROM ratsites AS sit
			LEFT OUTER JOIN ratpersonnes AS pers ON pers.pers_id=sit.pers_id
			WHERE sit.sit_id='.$Session['site']);
		if($req->next_record())
			{
			if($req->f('pers_id')=='') trigger_error("proprietaire non defini <site>".$Session['site']."</site>", E_USER_WARNING);
			elseif($req->f('pers_courriel')=='') trigger_error("courriel du proprietaire non defini <pers>".$req->f('pers_id')."</pers>", E_USER_WARNING);
			else $result = $req->f('pers_courriel');
			}
		else trigger_error("site non trouve <site>".$Session['site']."</site>", E_USER_WARNING);
		}
	else
		{
  	global $site;
  	
  	$result = getData('rat', 'proprio.courriel', '');
  	if($result=='') 
  		{
  		trigger_error("courriel du proprietaire non defini <site>$site</site>", E_USER_WARNING);
  		$result = ROOT_MAIL;
  		}
		}
	return $result;
	}
	
function proprio_courriel($email, $titre, $message)
	{
	return courriel(getproprio(), $email, $titre, $message);
	}

/**************************************************************************************
  appel de la lib rat
**************************************************************************************/

include CHEMIN_LIBS.'rat.lib.php';

?>