<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = gestion de tous les trucs propres  l'admin
* *************************************************************************************
* Creation en dcembre 2001
* valid
**************************************************************************************/

/**************************************************************************************
  tout pour le journal
**************************************************************************************/

function AddLog($msg, $file='erreurs.log', $site='')
//ajout d'une ligne de log dans le fichier dsign
  {
  if(empty($site)) $f = fopen(CHEMIN_JOURNAUX.$file, 'a+');
  else $f = fopen(CHEMIN_JOURNAUX.$site.'/'.$file, 'a+');
  fwrite($f, '<log><date>'.TxtXml(date('d/M/Y H:i:s', time())).'</date><msg>'.$msg."</msg></log>");
  fclose($f);
  }

/**************************************************************************************
  manipulations
**************************************************************************************/
global $HTTP_POST_VARS, $HTTP_GET_VARS, $Session;

function ComboLangues($langue)
//remplit une combobox avec la liste des langues pour le site en cours
  {
  global $Session;

  return Sql2options('
    SELECT lang_abrege AS chp1, lang_nomtraduit AS chp2
    FROM ratlangues l
      INNER JOIN ratlnk_sitelangue AS sl ON sl.lang_id=l.lang_id AND sl.sit_id='.$Session['site'],
    $langue);
  }

function GetParam($nom, &$destination, $valeur_defaut='')
//recupere un parametre en post, en get, et valeur par defaut si la variable n'est pas dfinie
  {
  global $HTTP_POST_VARS, $HTTP_GET_VARS;

  if(isset($HTTP_POST_VARS[$nom])) $destination = $HTTP_POST_VARS[$nom];
  elseif(isset($HTTP_GET_VARS[$nom])) $destination = $HTTP_GET_VARS[$nom];
  elseif(!isset($destination) && $valeur_defaut!='') $destination = $valeur_defaut;
  }

  /*todo deprecatd
function IsItems()
  {
  global $Session;

  return !empty($Session['items']) || !empty($Session['item']);
  }
 */

function GetCommandeAndItems(&$destination, $liste_commandes, &$datamodule, $elementident, $elementsident)
  //recupere pour le module en cours la commande et les items (post ou get), et configure le mode
  //d'affichage par defaut
  {
  global $HTTP_POST_VARS, $HTTP_GET_VARS, $Session;

  if(isset($Session['datamodule_'.$Session['module']])) $datamodule = $Session['datamodule_'.$Session['module']];
  else $datamodule = array();

  $result = '';
  GetParam($elementident, $items);
  if(!empty($items)) $result = $items;
  else
    {
    GetParam($elementsident, $items);
    if(!empty($items)) $result = $items;
    }

  $destination='cmd_rien';
  while($destination=='cmd_rien' && list(, $val) = each($liste_commandes))
    if(isset($HTTP_POST_VARS[$val])) $destination = $val;
    elseif(isset($HTTP_GET_VARS[$val])) $destination = $val;

  return $result;
  }

  /*todo deprecated
function CleanItems()
  //nettoyage des items dans la session
  {
  global $Session;

  //unset($Session['item']);
  unset($Session['items']);
  }
*/
/**************************************************************************************
  gestion des messages
**************************************************************************************/

$admmessages = array();

function msg_ajout($msg)
//ajout d'un message  destination de l'utilisateur
  {
  global $admmessages;

  $admmessages[] = $msg;
  }

function msg_affiche()
//affichage des messages
  {
  global $admmessages;

  if(count($admmessages)>0)
    {
    $tpl = ModeleAdmin('messages.html');
    for($ct=0, $max=count($admmessages); $ct<$max; $ct++)
      {
      $tpl->assign('MESSAGE', $admmessages[$ct]);
      $tpl->parse('MAIN.MESSAGE');
      }
    $tpl->assign('MSG_MESSAGESAPPLICATION', MSG_MESSAGESAPPLICATION);
    $tpl->parse('MAIN');
    $tpl->out('MAIN');
    }
  }

/**************************************************************************************
  gestion des modules
**************************************************************************************/

function EcranConfirmation($msg, $items, $cmdok, $cmdcancel)
//affichage de la demande de confirmation
  {
  global $HGS;

  $tpl = ModeleAdmin('confirmation.html');
  $tpl->assign('ACTION', '?');
  $tpl->assign('METHODE', 'post');
  $tpl->assign('HIDDEN', $HGS);
  $tpl->assign('QUESTION', $msg);
  if(!empty($items))
    {
    reset($items);
    $precis = '';
    while(list(,$val)=each($items)) $precis .= $val.' ';
    $tpl->assign('PRECISIONS', $precis);
    $tpl->parse('MAIN.PRECISIONS');
    }
  $tpl->assign('CMDOK', $cmdok);
  $tpl->assign('CMDCANCEL', $cmdcancel);
  $tpl->assign('MSG_OUI', MSG_OUI);
  $tpl->assign('MSG_NON', MSG_NON);

  $tpl->parse('MAIN');
  return $tpl->text('MAIN');
  }

function error_handler($type, $msg, $file, $line, $context)
  {
  switch($type)
    {
    case E_ERROR: //fatal runtime error
    case E_PARSE: //Runtime parse error
    case E_CORE_ERROR: //Fatal startup error
    case E_COMPILE_ERROR: //Fatal compile-time error
    case E_USER_ERROR: //User-triggered fatal error
      $gravite = 'fatale';
      echo "Une erreur fatale est survenue (\"$msg\"), cela va vous poser problme dans votre travail. Le webmestre a reu un message  ce sujet.<br>";
      break;

    case E_WARNING: //Non-fatal runtime error
    case E_CORE_WARNING: //Non-fatal startup error
    case E_COMPILE_WARNING: //Non-fatal compile-time error
    case E_USER_WARNING: //User-triggered non-fatal error
      $gravite = 'alerte';
      echo "Une erreur non fatale est survenue (\"$msg\"), cela peut vous poser problme dans votre travail. Le webmestre a reu un message  ce sujet.<br>";
      break;

    case E_NOTICE: //Non-fatal runtime notice
    case E_USER_NOTICE: //User-triggered notice
      $gravite = 'benigne';
      break;

    default: $gravite = 'inconnue';
    }

  AddLog("<type>".TxtXml($gravite)." (".TxtXml($type).")</type><file>$file (ligne ".TxtXml($line).")</file><msg>".
    $msg."</msg>");
  }

set_error_handler("error_handler");
?>