<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric
* Objet = quelques fonctions relative au coeur de RAT
* *************************************************************************************
* Creation en dcembre 2001
* valid
**************************************************************************************/

/**************************************************************************************
  chargement des fichiers
**************************************************************************************/
function Config($nom)
  {
  $chemin = CHEMIN_CODE.$nom.EXT;
  if(file_exists($chemin)) include $chemin;
  else trigger_error("fichier de config absent <fichier>".TxtXml($nom)."</fichier>", E_USER_WARNING);
  }

function Librairie($nom)
  {
  if(!defined('LIBRAT_'.$nom))
    {
    $chemin = CHEMIN_LIBS.$nom.'.lib'.EXT;
    if(file_exists($chemin)) include $chemin;
      else trigger_error("fichier de librairie absent <fichier>".TxtXml($nom)."</fichier>", E_USER_WARNING);
    define('LIBRAT_'.$nom, '1');
    }
  }

function Classe($nom)
  {
  if(!defined('CLASSRAT_'.$nom))
    {
    $chemin = CHEMIN_LIBS.$nom.'.class'.EXT;
    if(file_exists($chemin)) include $chemin;
      else trigger_error("fichier de classe absent <fichier>".TxtXml($nom)."</fichier>", E_USER_WARNING);
    define('CLASSRAT_'.$nom, '1');
    }
  }

function FonctionModule($module, $fonction, $optionnel=0)
  {
  $chemin = CHEMIN_MODULES.$module.'/'.$fonction.'.fonc'.EXT;
  if(file_exists($chemin)) include $chemin;
  elseif($optionnel==0) 
		trigger_error("fonction absente pour ce module <module>".TxtXml($module)."</module><fonction>".TxtXml($fonction)."</fonction>", E_USER_WARNING);
  }

function FonctionTousModules($fonction, $optionnel=0)
  {
  $dir = dir(CHEMIN_MODULES);
  while(false!=($item = $dir->read())) if($item!='.' and $item!='..')
    FonctionModule($item, $fonction, $optionnel);
  $dir->close();
  }

/**************************************************************************************
  Bases de donnes
**************************************************************************************/
Librairie('db_query');

function NewQuery($sql)
  {
  return (new DB_Query($sql));
  }

/**************************************************************************************
  Templates
**************************************************************************************/
Librairie('xtemplate');

function ModeleSite($fichier, $module='')
  {
  if($module=='') return (new XTemplate(CHEMIN_MODELES.$fichier));
  else return (new XTemplate(CHEMIN_MODELES.$module.'/'.$fichier));
  }

function ModeleAdmin($fichier, $module='')
  {
  if($module=='') return (new XTemplate(CHEMIN_ADMINMODELES.$fichier));
  else return (new XTemplate(CHEMIN_ADMINMODELES.$module.'/'.$fichier));
  }

?>