<?php
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric  
* Objet = librairie permettant d'afficher des combos permettant la selection des documents
* en les filtrant par dossiers
* *************************************************************************************
* Creation en dcembre 2001
* valid
**************************************************************************************/

function LstDocs_CodeJS()
//les fonctions JS
  {
  $corejs = "function CreerDocument() { this.nb = 0; }";
  $corejs .= "function AjtDos(lstdocs) {
    this.nb = 0;
    lstdocs[lstdocs.nb] = this;
    lstdocs.nb++; }";
  $corejs .= "function AD(dos, id, nom) {
    var doc = new Object;
    doc.id = id;
    doc.nom = nom;
    dos[dos.nb] = doc;
    dos.nb++; }";
  $corejs .= "function LoadDocuments(combo, lstdocs, iddos) {
    combo.options.length = lstdocs[iddos].nb;
    for(ct=0; ct<lstdocs[iddos].nb; ct++)
      combo.options[ct] = new Option(lstdocs[iddos][ct].nom, lstdocs[iddos][ct].id);
    combo.selectedIndex = 0; }";

  return $corejs;
  }

function LstDocs_Donnees($nom, $sql, &$dos, &$doc)
//gnration des listes de documents par dossiers
  {
  $req = NewQuery($sql);
  $dos = '';
  $doc = '';
  $ct = 0;
  $liste = '';

  if($req->next_record())
    {
    $liste = "var $nom = new CreerDocument();";
    $dos_id = 0;
    do
      {
      if($dos_id != $req->f('dos_id'))
        {
        $liste .= 'var D = new AjtDos('.$nom.');';
        $dos_id = $req->f('dos_id');
        $dos .= '<option value="'.$ct.'">'.$req->f('dos_nom').'</option>';
        $ct++;
        }
      $liste .= 'AD(D,'.$req->f('doc_id').',"'.str_replace('"', '\"', $req->f('doc_designation')).'");';
      if($ct<2) $doc .= '<option value="'.$req->f('doc_id').'">'.$req->f('doc_designation').'</option>';
      }
    while($req->next_record());
    }
  else trigger_error("erreur, rs vide <nom>".TxtXml($nom)."</nom><sql>".TxtXml($sql)."</sql>", E_USER_WARNING);

  return $liste;
  }


function GetJS(&$dos_libre, &$doc_libre, &$dos_all, &$doc_all)
//gnration de tout le code Javascript nccessaire pour filtrer les documents par dossiers
  {
  global $Session, $datamodule;
	
  $sqllibre = '
    SELECT dos.dos_id, dos.dos_nom, doc.doc_id, doc.doc_designation, rud.rub_id
    FROM ratdocuments AS doc
      INNER JOIN ratdossiers AS dos ON doc.dos_id=dos.dos_id
      INNER JOIN ratlnk_dossite AS dsi ON dsi.dos_id=dos.dos_id
        AND dsi.sit_id='.$Session['site'].'
      LEFT JOIN ratlnk_rubdoc AS rud ON rud.doc_id=doc.doc_id
		HAVING rud.rub_id IS NULL ORDER BY dos.dos_id';

  $sqlall = '
    SELECT dos.dos_id, dos.dos_nom, doc.doc_id, doc.doc_designation
    FROM ratdocuments AS doc
      INNER JOIN ratdossiers AS dos ON doc.dos_id=dos.dos_id
      INNER JOIN ratlnk_dossite AS dsi ON dsi.dos_id=dos.dos_id
        AND dsi.sit_id='.$Session['site'].'
      LEFT JOIN ratlnk_rubdoc AS rud ON rud.doc_id=doc.doc_id AND rud.rub_id='.$datamodule['rub'].'
		WHERE rud.doc_id IS NULL ORDER BY dos.dos_id';

  $result = LstDocs_CodeJS();
  $result .= LstDocs_Donnees('dlLibres', $sqllibre, $dos_libre, $doc_libre);
  $result .= LstDocs_Donnees('dlAll', $sqlall, $dos_all, $doc_all);

  return $result;
  }
	
function LstDocsSelect_Donnees($nom, $sql, &$dos, $dos_sel, &$doc, $doc_sel)
//gnration des listes de documents par dossiers
  {
  $req = NewQuery($sql);
  $dos = '<option value="0">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>';
  $doc = $dos;
  $ct = 1;

  if($req->next_record())
    {
    $dos_id = 0;
    do
      {
      if($dos_id != $req->f('dos_id'))
        {
        $dos_id = $req->f('dos_id');
				$selected = ($dos_id == $dos_sel) ? ' selected' : '';
        $dos .= '<option value="'.$ct.'"'.$selected.'>'.$req->f('dos_nom').'</option>';
        $ct++;
        }
      if($dos_id == $dos_sel) 
				{
				$selected = ($req->f('doc_id') == $doc_sel) ? ' selected' : '';
				$doc .= '<option value="'.$req->f('doc_id').'"'.$selected.'>'.$req->f('doc_designation').'</option>';
				}
      }
    while($req->next_record());
    }
  else trigger_error("erreur, rs vide <nom>".TxtXml($nom)."</nom><sql>".TxtXml($sql)."</sql>", E_USER_WARNING);
	}
	
function GetJSListe()
  {
	global $Session;	
	
	$sql = '
	  SELECT dos.dos_id, dos.dos_nom, doc.doc_id, doc.doc_designation
  	FROM ratdocuments AS doc
    	INNER JOIN ratdossiers AS dos ON doc.dos_id=dos.dos_id
    	INNER JOIN ratlnk_dossite AS dsi ON dsi.dos_id=dos.dos_id AND dsi.sit_id='.$Session['site'].'
		ORDER BY dos.dos_id';
		
  $req = NewQuery($sql);
  $ct = 0;
  $liste = '';
	$nom = 'dlAll';

  if($req->next_record())
    {
    $liste = "var $nom = new CreerDocument();var D = new AjtDos(dlAll);AD(D,0,\"\");";
    $dos_id = 0;
    do
      {
      if($dos_id != $req->f('dos_id'))
        {
        $liste .= 'var D = new AjtDos('.$nom.');';
        $dos_id = $req->f('dos_id');
        $ct++;
        }
      $liste .= 'AD(D,'.$req->f('doc_id').',"'.str_replace('"', '\"', $req->f('doc_designation')).'");';
      }
    while($req->next_record());
    }
  else trigger_error("erreur, rs vide <site>".TxtXml($Session['site'])."</site>", E_USER_WARNING);

  return LstDocs_CodeJS().$liste;
  }
	
function GetJSSelect(&$dos, $dos_sel, &$doc, $doc_sel)
	{
	global $Session;	
	
	$sqlall = '
	  SELECT dos.dos_id, dos.dos_nom, doc.doc_id, doc.doc_designation
  	FROM ratdocuments AS doc
    	INNER JOIN ratdossiers AS dos ON doc.dos_id=dos.dos_id
    	INNER JOIN ratlnk_dossite AS dsi ON dsi.dos_id=dos.dos_id AND dsi.sit_id='.$Session['site'].'
		ORDER BY dos.dos_id';
	
	LstDocsSelect_Donnees('dlAll', $sqlall, $dos, $dos_sel, $doc, $doc_sel);
	}

?>