<?
/**************************************************************************************
* Projet = RAT
* Version de cration = 0.3
* Codeur = Cdric  
* Objet = fonctions propres  la vitrine
* *************************************************************************************
* Creation 
* valid
**************************************************************************************/

/**************************************************************************************
  tout pour le journal
**************************************************************************************/

Librairie('utilitaires');

function afficheerreur($a, $b="") //ici
  {
  trigger_error("deprecated", E_USER_WARNING);
  }

function AddLog($msg, $file='erreurs.log')
  {
  $f = fopen(CHEMIN_JOURNAUX.DOSSIER_SITE.'/'.$file, 'a+');
  fwrite($f, "<log><date>".TxtXml(date('d/M/Y H:i:s', time()))."</date>".utf8_encode($msg)."</log>");
  fclose($f);
  }

function ListeLangues()
  {
  global $rat;

  $lang_dispo = explode(',', getData('documents', numformat($rat['doc'], 6).'.lang', LANGUES_LISTE));
  reset($lang_dispo);
  $result = '';
  $rat['doc_lang'] = '';
	
  while(list(, $val)=each($lang_dispo))
    {
    if($val==$rat['lang']) $rat['doc_lang'] = $val;
    $result .= '<a href="?rub='.$rat['rub'].'&doc='.$rat['doc'].'&part='.$rat['part'].'&lang='.$val.'">'.$val.'</a>&nbsp;';
    }
  if(empty($rat['doc_lang'])) $rat['doc_lang'] = $lang_dispo[0];

  return $result;
  }
	
function error_handler($type, $msg, $file, $line, $context)
	{
	switch($type)
		{
		case E_ERROR: //fatal runtime error 
		case E_PARSE: //Runtime parse error
		case E_CORE_ERROR: //Fatal startup error
		case E_COMPILE_ERROR: //Fatal compile-time error
		case E_USER_ERROR: //User-triggered fatal error
			$gravite = 'fatale';
			echo "Suite  un problme indpendant de notre volont, ce document est indisponible. Veuillez nous en excuser.<br>".
				"Le webmestre a reu un message  ce sujet.";			
			break;

		case E_WARNING: //Non-fatal runtime error 
		case E_CORE_WARNING: //Non-fatal startup error
		case E_COMPILE_WARNING: //Non-fatal compile-time error
		case E_USER_WARNING: //User-triggered non-fatal error
			$gravite = 'alerte';
			break;

		case E_NOTICE: //Non-fatal runtime notice
		case E_USER_NOTICE: //User-triggered notice
			$gravite = 'benigne';
			break;
			
		default: $gravite = 'inconnue';
		}		
	
	AddLog("<type>".TxtXml($gravite)." (".TxtXml($type).")</type><file>$file (ligne ".TxtXml($line).")</file><msg>".
		$msg."</msg>"); 
	}
	
set_error_handler("error_handler");

?>