<?php

global $msg_gene, $Session;

Librairie('utilitaires');
Librairie('rawdata');
Librairie('personnes');
Classe('documents');

if(!defined('MENU_REGENERE')) {
define('MENU_REGENERE', 1);

function rub_generepage($rub_id, $lang_id)
//gnration d'une page listant les documents lis  la rubrique
	{
  $tpl = ModeleSite('tplpage_liste.html', 'menu');	
	
	//gestion du document
	// todo " dfinir"
	
	//gestion de la liste	
	$req = NewQuery('select
      doc.doc_id, doc.doc_modification,
      dol.dol_titre, dol.dol_description, 
      pers.pers_prenom, pers.pers_nom
    from ratdocuments as doc
      inner join ratlnk_rubdoc as rud on rud.rub_id='.$rub_id.' and rud.doc_id=doc.doc_id
      inner join ratlnk_doclang as dol on dol.doc_id=doc.doc_id and dol.lang_id='.$lang_id.'
      inner join ratpersonnes as pers on pers.pers_id=doc.pers_id
    where doc.doc_visible=1 and dol.dol_visible=1');
	while($req->next_record())
		{
		$tpl->assign('LNK', '?doc='.$req->f('doc_id').'&[[INFOS]]');
		$tpl->assign('TITRE', TxtHTML($req->f('dol_titre')));
		$tpl->assign('AUTEUR', TxtHTML($req->f('pers_prenom')).'&nbsp;'.TxtHTML($req->f('pers_nom')));
		$tpl->assign('DATE', date_m2p($req->f('doc_modification')));
		$tpl->assign('DESCRIPTION', TxtHTML($req->f('dol_description')));
		$tpl->parse('MAIN.LISTE.LIGNE');
		}
		
	$tpl->parse('MAIN.LISTE');		
	$tpl->parse('MAIN');
	return $tpl->text('MAIN');
	}

function rub_genereniveau_zone($rub_id, $ouverts, &$niveaux, &$tpl, $niveau=1)
	//todo : mettre  niveau avec l'quivalent arbo
{
  $result = '';
  //todo
  $req = NewQuery('
    select rub.rub_id, rul.rul_titre, rul.rul_description, rub.rub_doc_id, rub.maindoc_id
    from ratrubriques as rub
      inner join ratlangues as lang on lang.lang_abrege="fr"
      inner join ratlnk_rublang as rul on rub.rub_id=rul.rub_id and lang.lang_id=rul.lang_id
    where rub.rubpere_id='.$rub_id.' and rub.sit_id=1 and rub.rub_visible=1
    order by rub.rub_place');
  while($req->next_record())
    {
    $niveaux[$niveau] = true;
		if($req->f('rub_doc_id')=='') $doc_lie = $req->f('maindoc_id'); else $doc_lie = $req->f('rub_doc_id');
    $tpl->assign('URL', '?rub='.$req->f('rub_id').'&doc='.$doc_lie);
    $tpl->assign('TITRE', $req->f('rul_titre'));
    $tpl->assign('BULLE', $req->f('rul_description'));
    if(in_array($req->f('rub_id'), $ouverts))
      if($req->f('rub_id')==$ouverts[0]) $tpl->parse('MAIN.ZONE'.$niveau.'.ITEM'.$niveau.'.COURANT');
      else $tpl->parse('MAIN.ZONE'.$niveau.'.ITEM'.$niveau.'.OUVERT');
    else $tpl->parse('MAIN.ZONE'.$niveau.'.ITEM'.$niveau.'.NORMAL');
    $tpl->parse('MAIN.ZONE'.$niveau.'.ITEM'.$niveau);
    if(in_array($req->f('rub_id'), $ouverts))
      rub_genereniveau_zone($req->f('rub_id'), $ouverts, $niveaux, $tpl, $niveau+1);
    }
  return $result;
}

function rub_generebloc_zone($rub_id)
	//todo : mettre  niveau avec l'quivalent arbo
{
  $tpl = new XTemplate('tplmenu_simplearbohaut.html');
  //modele vitrine
  //recherche du chemin ouvert
  $ouverts = array();
  $niveaux = array();
  $rub_parcours = $rub_id;
  while($rub_parcours!=0)
    {
    $req = NewQuery('SELECT rubpere_id FROM ratrubriques WHERE rub_id='.$rub_parcours);
    if(!$req->next_record()) ; //todo erreur
    $ouverts[] = $rub_parcours;
    $rub_parcours = $req->f('rubpere_id');
    }

  //affichage du menu
  rub_genereniveau_zone(0, $ouverts, $niveaux, $tpl);
  reset($niveaux);
  while(list($key,)=each($niveaux)) $tpl->parse('MAIN.ZONE'.$key);
  $tpl->parse('MAIN');
  return $tpl->text('MAIN');
}

function rub_genereniveau_arbo($rub_id, $langue, $ouverts, &$tpl, $niveau=1)
//gnration d'un niveau en arborescence
{
  global $Session;
  $result = '';
  $req = NewQuery('
    select rub.rub_id, rul.rul_titre, rul.rul_description, rub.rub_doc_id, rub.maindoc_id
    from ratrubriques as rub
      inner join ratlangues as lang on lang.lang_abrege="'.$langue.'"
      inner join ratlnk_rublang as rul on rub.rub_id=rul.rub_id and lang.lang_id=rul.lang_id
    where rub.rubpere_id='.$rub_id.' and rub.sit_id='.$Session['site'].' and rub.rub_visible=1
			and (maindoc_id is not null or rub_doc_id is not null)
    order by rub.rub_place');
  while($req->next_record())
    {
		if($req->f('maindoc_id')!='') $doc_lie = $req->f('maindoc_id'); else $doc_lie = $req->f('rub_doc_id');
    $tpl->assign('URL', '?rub='.$req->f('rub_id').'&lang='.$langue.'&doc='.$doc_lie);
    $tpl->assign('TITRE', str_replace(' ', '&nbsp;', TxtHTML($req->f('rul_titre'))));
    $tpl->assign('BULLE', $req->f('rul_description'));
    if(in_array($req->f('rub_id'), $ouverts))
      if($req->f('rub_id')==$ouverts[0]) $tpl->parse('MAIN.ITEMS.ITEM'.$niveau.'.COURANT');
      else $tpl->parse('MAIN.ITEMS.ITEM'.$niveau.'.OUVERT');
    else $tpl->parse('MAIN.ITEMS.ITEM'.$niveau.'.NORMAL');
    $tpl->parse('MAIN.ITEMS.ITEM'.$niveau);
    $tpl->parse('MAIN.ITEMS');
    if(in_array($req->f('rub_id'), $ouverts))
      rub_genereniveau_arbo($req->f('rub_id'), $langue, $ouverts, $tpl, $niveau+1);
    }
  return str_replace('\n', '', $result);
}

function rub_generebloc_arbo($rub_id, $langue)
{
  $tpl = ModeleSite('tplmenu_simplearbo.html', 'menu');
  //recherche du chemin ouvert
  $ouverts = array();
  $rub_parcours = $rub_id;
  while($rub_parcours!=0)
    {
    $req = NewQuery('SELECT rubpere_id FROM ratrubriques WHERE rub_id='.$rub_parcours);
    if(!$req->next_record()) trigger_error("rubrique non trouvee <rub>$rub_id</rub>", E_USER_WARNING);
    $ouverts[] = $rub_parcours;
    $rub_parcours = $req->f('rubpere_id');
    }

  //affichage du menu
  rub_genereniveau_arbo(0, $langue, $ouverts, $tpl);
  $tpl->parse('MAIN');
	return str_replace("\r", '', str_replace('	', '', str_replace("\n", "", $tpl->text('MAIN'))));
}

} //fin !defined('ERREURSVITRINE_REGENERE')

/**************************************************************************************************
* gestion des documents gnrs
**************************************************************************************************/

$req = NewQuery('
select distinct
  rub.rub_id, rub.rub_doc_id, rub.maindoc_id,
  rul.rul_titre, rul.rul_description,
  rul.lang_id,
  doc.doc_id, doc.doc_refresh
from ratrubriques as rub
  inner join ratlnk_rublang as rul on rul.rub_id=rub.rub_id
  inner join ratlangues as lang on lang.lang_id=rul.lang_id
  left outer join ratdocuments as doc on rub.rub_doc_id=doc.doc_id
where rub.sit_id='.$Session['site'].' and rub.rub_visible=1 and rub.rub_doc_refresh=1 order by rub.rub_id'); 

$rubrique = 0;
while($req->next_record())
  {		
	if($rubrique!=$req->f('rub_id')) 
		{
		$rubrique = $req->f('rub_id');
		$document = 0;
		}
	
	if($document==0) $document = $req->f('rub_doc_id');
	
  if($document==0)
    { //gestion pour la cration ventuelle d'un document
		$doc = new CClassDoc(0, $req->f('lang_id'));
		$doc->Personne(Personne_systeme());
		$doc->Module(module_id('menu'));
		$doc->Visible(true);
		$doc->EnTete(false);
		$doc->Navigation(false);
		$doc->Sommaire(false);
		$doc->Dossier(dos_systeme($Session['site']));
		$doc->Designation('liste rubrique '.$req->f('rub_id'));
		$document = $doc->id;
    }
  else $doc = new CClassDoc($document, $req->f('lang_id'));

	//sauve le document pour la langue
  $doc->Titre('Rubrique '.$req->f('rul_titre')); //todo traduction
  $doc->MotsClefs('');
  $doc->Description($req->f('rul_description'));
  $doc->VisLang(true);
  $doc->Sauver();
	$document = $doc->id;
	NewQuery('UPDATE ratrubriques SET rub_doc_id='.$document.', rub_doc_refresh=0 WHERE rub_id='.$req->f('rub_id'));
	
	//sauve la page
	$pag = $doc->Page(1);
	$pag->Ident('liste');
	$pag->Visible(true);
	$pag->TexteCommun(false);
	$pag->VisLang(true);
	$pag->Titre('Rubrique '.$req->f('rul_titre')); //todo traduction
	$pag->Description($req->f('rul_description'));
	$pag->Texte(rub_generepage($rubrique, $req->f('lang_id')));	
	$pag->Sauver(); 
	
	$msg_gene[] = 'MENU: gnration page de rubrique '.$req->f('rul_titre');
  }

/**************************************************************************************************
* gnration du menu
**************************************************************************************************/

if(getData('menu', 'menu.refresh', 1)==0) return '';

$req = NewQuery('SELECT rub_id FROM ratrubriques WHERE sit_id='.$Session['site'].' AND rub_visible=1');
$liste = explode(',', LANGUES_LISTE);
while($req->next_record())
  {
  reset($liste);
  while(list(, $val)=each($liste))
    blocSauve('menu', numformat($req->f('rub_id'), 6).'.'.$val, rub_generebloc_arbo($req->f('rub_id'), $val));
  }

reset($liste);
while(list(, $val)=each($liste))
  blocSauve('menu', numformat(0, 6).'.'.$val, rub_generebloc_arbo(0, $val));

$msg_gene[] = 'gnration menu';
setData('menu', 'menu.refresh', 0);

?>