<?

/**************************************************************************************
  commandes acceptes par le module
**************************************************************************************/
$liste_commandes = array(
	'cmd_envoi',
	'cmd_ztyps',
 	'cmd_inscrits',
  'cmd_chgvaleur',
  'cmd_addtype',
  'cmd_supptype',
  'cmd_supprconf',
  'cmd_supprimer',
  'cmd_annuler',
  'cmd_montrer',
  'cmd_cacher',
  'cmd_ajouter',
  'cmd_editer');
	
/**************************************************************************************
  commandes
**************************************************************************************/

global $Session, $datamodule, $HTTP_POST_VARS, $HTTP_GET_VARS;
Librairie('zooms');

$data = GetCommandeAndItems($cmd, $liste_commandes, $datamodule, '', 'zooms');
if(isset($datamodule['zoom'])) unset($datamodule['zoom']);

switch($cmd)
  {
  case 'cmd_rien' : break;

	case 'cmd_envoi' : 
    $Session['mode'] = 'envoi';
    break;

	case 'cmd_ztyps' :
    $Session['mode'] = 'zoomtypes';
    break;

  case 'cmd_inscrits' :
    $Session['mode'] = 'inscrits';
    break;

  case 'cmd_chgvaleur' :
    if(empty($HTTP_POST_VARS['new_valeur']) || !is_numeric($HTTP_POST_VARS['new_valeur']))
      msg_ajout('Aucune valeur dfinie'); //TODO TRADUCTION
    elseif(empty($data))
      msg_ajout('Aucun zoom slectionn');
    else
      {
      $datamodule['zooms'] = $data;
      reset($data);
      while(list($key, $val)=each($data)) zoom_chgvaleur($key, $HTTP_POST_VARS['new_valeur']);
      }
    break;

  case 'cmd_addtype' :
    if(empty($HTTP_POST_VARS['new_type'])) msg_ajout('Aucun type dfini'); //TODO TRADUCTION
    elseif(empty($data)) msg_ajout(MSG_NONESELECTED);
    else
      {
      msg_ajout("Liaison avec un type");
      $datamodule['zooms'] = $data;
      reset($data);
      while(list($key, $val)=each($data)) zoom_addtype($key, $HTTP_POST_VARS['new_type']);
      }
    break;
		
  case 'cmd_montrer' :     
    if(empty($data)) msg_ajout(MSG_NONESELECTED);
    else
      {
      msg_ajout("Les zooms deviennent visibles");
      $datamodule['zooms'] = $data;
      reset($data);
      while(list($key, $val)=each($data)) zoom_setvisible($key, 1);
      }
    break;

  case 'cmd_cacher' : 
    if(empty($data)) msg_ajout(MSG_NONESELECTED);
    else
      {
      msg_ajout("Les zooms se cachent");
      $datamodule['zooms'] = $data;
      reset($data);
      while(list($key, $val)=each($data)) zoom_setvisible($key, 0);
      }
    break;

  case 'cmd_supptype' :
    if(empty($HTTP_POST_VARS['new_type'])) msg_ajout('Aucun type dfini'); //TODO TRADUCTION
    elseif(empty($data)) msg_ajout(MSG_NONESELECTED);
    else
      {
      msg_ajout("Dtachement d'un type");
      $datamodule['zooms'] = $data;
      reset($data);
      while(list($key, $val)=each($data)) zoom_supptype($key, $HTTP_POST_VARS['new_type']);
      }
    break;

  case 'cmd_supprconf' :
    if(!empty($data))
      {
      $datamodule['zooms'] = $data;
      $datamodule['confirmation'] = 1;
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_supprimer' :
    unset($datamodule['confirmation']);
    if(!empty($datamodule['zooms']))
      {
      reset($datamodule['zooms']);
      while(list($val,)=each($datamodule['zooms']))
        {
        msg_ajout('suppression de "'.zoom_designation($val).'"'); //TODO TRADUCTION
        zoom_supprimer($val);
        }
      unset($datamodule['zooms']);
      }
    else msg_ajout(MSG_NONESELECTED);
    break;

  case 'cmd_annuler' :
    unset($datamodule['confirmation']);
    break;
		
	case 'cmd_ajouter' : 
		if(!empty($HTTP_POST_VARS['add_doc']) or !empty($HTTP_POST_VARS['add_url']))
			{
			$Session['mode'] = 'edit';
			$datamodule['zoom'] = zoom_ajout($HTTP_POST_VARS['add_doc'], $HTTP_POST_VARS['add_url'], $Session['id_personne'], $Session['site']);
			msg_ajout("Ajout d'un zoom");
			}
		else msg_ajout("Il faut remplir le document ou l'url pour crer un zoom");
		break;
		
	case 'cmd_editer' : 
		$Session['mode'] = 'edit';
		$datamodule['zoom'] = $HTTP_GET_VARS['cmd_editer'];
		break;

  default : trigger_error("commande inconnue <cmd>".TxtXml($cmd)."</cmd>", E_USER_WARNING);
  }

/**************************************************************************************
  gestion du filtre
**************************************************************************************/

function FromPost($valeur)
  {
  global $HTTP_POST_VARS, $datamodule;
  if(isset($HTTP_POST_VARS[$valeur])) $datamodule[$valeur] = $HTTP_POST_VARS[$valeur];
  }

function FromGet($valeur)
  {
  global $HTTP_GET_VARS, $datamodule;
  if(isset($HTTP_GET_VARS[$valeur])) $datamodule[$valeur] = $HTTP_GET_VARS[$valeur];
  }

if(isset($HTTP_POST_VARS['nofiltre']))
  {
  unset($datamodule['filtre_auteur']);
  unset($datamodule['filtre_motsclefs']);
  unset($datamodule['filtre_type']);
  unset($datamodule['filtre_ml']);
  }
else
  {
  FromPost('filtre_auteur');
  FromPost('filtre_motsclefs');
  FromPost('filtre_type');
  unset($datamodule['filtre_ml']);
  FromPost('filtre_ml');
  }
FromGet('sort');
FromGet('sens');
if(!isset($datamodule['filtre_module'])) $datamodule['filtre_module'] = 'totalvide';

?>